/*
$Log: speech_out.c,v $
Revision 1.12  2001/11/01 20:17:59  ganter
v1.0 added spanish voice output

Revision 1.11  2001/09/30 18:45:27  ganter
v0.29
added choice of map type

Revision 1.10  2001/09/30 12:09:43  ganter
added help menu

Revision 1.9  2001/09/28 15:43:56  ganter
v0.28 changed layout, some bugfixes

Revision 1.8  2001/09/25 23:49:44  ganter
v 0.27

Revision 1.7  2001/09/23 22:31:14  ganter
v0.26

Revision 1.6  2001/09/18 05:33:06  ganter
..

Revision 1.5  2001/09/17 00:29:38  ganter
added speech output of bearing

Revision 1.4  2001/09/16 21:36:05  ganter
speech output is working

Revision 1.3  2001/09/16 19:12:35  ganter
...

*/


/*  There must be the software "festival" running in server mode */
/*  http://www.speech.cs.cmu.edu/festival */


/*  Include Dateien */
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <math.h>
#include <sys/time.h>
#include "gtk/gtk.h"
#include "gdk-pixbuf/gdk-pixbuf.h"
#include <locale.h>
#include <time.h>

/*  Defines for gettext I18n */
# include <libintl.h>
# define _(String) gettext(String)
# ifdef gettext_noop
#  define N_(String) gettext_noop(String)
# else
#  define N_(String) (String)
# endif




extern gint statusid, debug, havespeechout, posmode, muteflag;
gint speechsock;
extern enum
{ english, german, spanish }
voicelang;


#define SPEACHOUTSERVER "localhost"


gint
speech_out_init ()
{
  struct sockaddr_in server;
  struct hostent *server_data;

/*  open socket to port 1314 */
  if ((speechsock = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      return (FALSE);
    }
  server.sin_family = AF_INET;
/*  We retrieve the IP address of the server from its name: */
  if ((server_data = gethostbyname (SPEACHOUTSERVER)) == NULL)
    {
      return (FALSE);
    }
  memcpy (&server.sin_addr, server_data->h_addr, server_data->h_length);
  server.sin_port = htons (1314);
/*  We initiate the connection  */
  if (connect (speechsock, (struct sockaddr *) &server, sizeof server) < 0)
    {
      return (FALSE);
    }


  return TRUE;
}


gint
speech_out_speek (char *text)
{
  gint e;
  if (!havespeechout)
    return 0;
  if (posmode)
    return 0;

  if (debug)
    g_print (text);
  e = write (speechsock, text, strlen (text));

  return e;
}

/*  if second parameter is TRUE, then also greeting is spoken */
gint
speech_saytime_cb (GtkWidget *widget, guint datum)
{
  time_t t;
  struct tm *ts;
  gchar buf[200];

  if (muteflag)
    return TRUE;

  time (&t);
  ts = localtime (&t);

  if (havespeechout)
    switch (voicelang)
      {
      case english:
	if (datum == 1)
	  {
	    if ((ts->tm_hour >= 0) && (ts->tm_hour < 12))
	      sprintf (buf, "(SayText \"Good Morning,\")\n");
	    if ((ts->tm_hour >= 12) && (ts->tm_hour < 18))
	      sprintf (buf, "(SayText \"Good afternoon,\")\n");
	    if (ts->tm_hour >= 18)
	      sprintf (buf, "(SayText \"Good evening,\")\n");
	    speech_out_speek (buf);
	  }
	sprintf (buf,
		 "(SayText \"it is %d o clock and %d minutes.\")\n",
		 ts->tm_hour, ts->tm_min);
	speech_out_speek (buf);
	break;
      case spanish:
	if (datum == 1)
	  {
	    if ((ts->tm_hour >= 0) && (ts->tm_hour < 12))
	      sprintf (buf, "(SayText \"buenos das,\")\n");
	    if ((ts->tm_hour >= 12) && (ts->tm_hour < 18))
	      sprintf (buf, "(SayText \"buenos tardes,\")\n");
	    if (ts->tm_hour >= 18)
	      sprintf (buf, "(SayText \"buenas noches,\")\n");
	    speech_out_speek (buf);
	  }
	if (ts->tm_hour == 1)
	sprintf (buf,
		 "(SayText \"es la una y %d minutos.\")\n",
		  ts->tm_min);
	else
	sprintf (buf,
		 "(SayText \"son las %d horas y %d minutos.\")\n",
		 ts->tm_hour, ts->tm_min);
	speech_out_speek (buf);
	break;
      case german:
	if (datum == 1)
	  {
	    if ((ts->tm_hour >= 0) && (ts->tm_hour < 12))
	      sprintf (buf, "(SayText \"Guten Morgen,\")\n");
	    if ((ts->tm_hour >= 12) && (ts->tm_hour < 18))
	      sprintf (buf, "(SayText \"Guten Tag,\")\n");
	    if (ts->tm_hour >= 18)
	      sprintf (buf, "(SayText \"Guten Abend,\")\n");
	    speech_out_speek (buf);
	  }
	if (ts->tm_hour == 1)
	  sprintf (buf, "(SayText \"es ist ein Uhr %d\")\n", ts->tm_min);
	else
	  sprintf (buf,
		   "(SayText \"es ist %d Uhr %d\")\n", ts->tm_hour,
		   ts->tm_min);
	speech_out_speek (buf);

      }

  return TRUE;

}
