/*
$Log: splash.c,v $
Revision 1.10  2001/10/14 10:41:59  ganter
v0.32 correct path for prefix other than /usr/local

Revision 1.9  2001/10/13 23:04:56  ganter
corrected paths for locale and pixmap, ./configure --prefix= works now as
expected

Revision 1.8  2001/09/30 18:45:27  ganter
v0.29
added choice of map type

Revision 1.7  2001/09/30 15:54:32  ganter
added minimap, removed gpsdrivelogo

Revision 1.6  2001/09/28 15:43:56  ganter
v0.28 changed layout, some bugfixes

Revision 1.5  2001/08/29 19:05:20  ganter
trying splashfile also in current dir

Revision 1.4  2001/08/29 13:59:56  ganter
removed large xpm file, load png instead

Revision 1.3  2001/08/26 15:49:09  ganter
indent

Revision 1.2  2001/08/26 15:47:19  ganter
works fine

Revision 1.1  2001/08/26 15:03:15  ganter
added splash.c

*/
#include "gtk/gtk.h"
#include "gdk-pixbuf/gdk-pixbuf.h"
#include <unistd.h>
#include <stdio.h>


/*  Defines for gettext I18n */
# include <libintl.h>
# define _(String) gettext(String)
# ifdef gettext_noop
#  define N_(String) gettext_noop(String)
# else
#  define N_(String) (String)
# endif


extern GtkWidget *hauptfenster;
GtkWidget *splash_window;

void splash (void);

gint
splashaway_cb (GtkWidget * widget, gpointer datum)
{
  gtk_widget_destroy (splash_window);
  return (FALSE);
}

void
splash (void)
{
  gchar xpmfile[400];
  GdkPixbuf *image;
  GdkPixmap *ip_pixmap;
  GdkBitmap *ip_bitmap;
  GtkWidget *pixm;

/*  I don't know where the right place for pixmaps is */
  sprintf (xpmfile, "%s/%s", DATADIR, "gpsdrivesplash.png");

/* Splash Window */
  splash_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (splash_window), "gpsdrive");
  gtk_window_set_position (GTK_WINDOW (splash_window), GTK_WIN_POS_CENTER);

  gtk_widget_realize (splash_window);
  gdk_window_set_decorations (GTK_WIDGET (splash_window)->window, 0);

  gtk_widget_realize (splash_window);
  image = gdk_pixbuf_new_from_file (xpmfile);
  if (image == NULL)
    {
/*  	ok, file is not where it should, trying current directory */
      image = gdk_pixbuf_new_from_file ("gpsdrivesplash.png");
    }

/*  file couldn't be loaded */
  if (image == NULL)
    {
      g_print ("\nunable to open splash picture\n");
      return;
    }
  gdk_pixbuf_render_pixmap_and_mask (image, &ip_pixmap, &ip_bitmap, 128);
  pixm = gtk_pixmap_new (ip_pixmap, ip_bitmap);
  gdk_pixbuf_unref (image);
  gdk_pixmap_unref (ip_pixmap);
  if (ip_bitmap)
    {
      gdk_bitmap_unref (ip_bitmap);
    }


  gtk_container_add (GTK_CONTAINER (splash_window), pixm);

  gtk_widget_show (pixm);
  gtk_widget_show (splash_window);
  while (gtk_events_pending ())
    gtk_main_iteration ();

  gtk_timeout_add (3000, (GtkFunction) splashaway_cb, NULL);

}


gint
help_cb (GtkWidget *widget, guint datum)
{

  GtkWidget *popup;
  GtkWidget *knopf2;
  GtkWidget *text;
  GtkWidget *scrollbar;
  GtkWidget *hbox;
gchar *meintext =
  _("GpsDrive Help\n\n"
    "GPSDRIVE (c) 2001 Fritz Ganter <ganter@ganter.at>\n\n"
    "-------------------------------------------------\n"
    "Website: www.kraftvoll.at/software\n"
    "Disclaimer: Please do not use for navigation. \n\n"
    "*************************************************\n\n"
    "	       Starting the program:\n\n"
    "There are to modes to communicate with the GPS receiver: NMEA and GARMIN mode. \n\n"
    "The NMEA mode is the most common communication standard. GARMIN mode is only "
    "available on some GARMIN receivers.\n\n"
    "GARMIN mode is faster (some data packets per second, in NMEA mode 1 packet "
    "in 2 seconds), but the calculations the program makes are perhaps not "
    "so accurate. There is also no display of the satellites signal level. \n\n"
    "If you want GARMIN mode, be sure to  have no \"gpsd\" running. In this "
    "case, your GARMIN GPS must be set in the transfer mode: \"GARMIN host\".\n\n"
    "In this mode, the program only gets lat/long data, the speed and "
    "direction it calculates itself. There is also no display of the "
    "satellite signal level (this data is not supported by GARMIN "
    "protocoll).\n\n"
    "After compiling and installing (install is needed for localisation) "
    "start the program \"gpsd\" (provided with GpsDrive) if you want to use "
    "NMEA mode.\n\n"
    "gpsd is a daemon which reads out the NMEA data from the GPS "
    "receiver. The settings /dev/ttyS0 and 4800 Baud are precompiled.\n\n"
    "There is also another gpsd from Remco Treffkorn using port 2947. If "
    "you start this gpsd, it will be found automagically. "
    "If you want to change this settings i.e. to the second serial port "
    "call it with:\n\n"
    "gpsd -serial /dev/ttyS1 \n\n"
    "Create a directory \".gpsdrive\" in your home directory. In this directory "
    "you should place your map files first (see below). \n\nDon't forget to "
    "edit the file \"map_koord.txt\" in the ~/.gpsdrive directory. This is "
    "not neccessary if you use only maps which you downloaded with GpsDrive"
    "or gpsfetchmap.\n\n"
    "You can also let the program download the maps. There is also a script "
    "\"gpsfetchmap\" to download the maps.\n\n"
    "Once gpsd is running you can start the program with\n\n"
    "gpsdrive\n\n"
    "For GARMIN mode you must not start gpsd.\n\n"
    "If you don't have a link /dev/gps to your serial device, or you use "
    "another port than ttyS0 start "
    "GpsDrive with\n\n"
    "./gpsdrive  -t /dev/ttyS1 \n\n"
    "for your second serial port.\n\n"
    "You see your position on the map and some infos in the statusline. You "
    "can zoom in and out. If you are moving outside your map, the next map "
    "is selected if one is available for your position.\n\n"
    "If you have no GPS receiver connected:\n"
    "-------------------------------------\n\n"
    "There is a build in simulator. It is automatically used if no GPS "
    "receiver is found.\n\n"
    "If you have created a waypoint file and have the right maps, you can "
    "click on SELECT TARGET to select your destination. The marker will move to this waypoint.\n\n"
    "I'm to lazy to go out of my bed, how can I test with my GARMIN GPS III?\n"
    "----------------------------------------------------------------------\n\n"
    "Your GARMIN has a built in simulator. Start it on the \"satellite "
    "screen\", the go to setup and enter a speed in the simulator menu. Then "
    "GOTO to a stored waypoint and look how fine GpsDrive work. "
    "Don't forget to download your maps first.\n\n"
    "Mouse control:\n"
    "--------------\n\n"
    "If you click with the left mouse button on the map you are in \"Display "
    "mode\" where a rectangle is the cursor and no position is shown. If you "
    "zoom or select another map scale, this is done for the position of the "
    "rectangle-cursor in the same manner as it would be your actual "
    "position.\n\n"
    "The middle mouse button switches back to normal mode. The same if you "
    "select a target with the right mouse button.  Shift-left-mouse-button "
    "and shift-right-mouse-button changes the map scale.\n\n"
    "************************************************************************\n\n"
    "How to get own maps?\n"
    "-------------------\n\n"
    "There must be a file called \"map_koord.txt\" in your ~/.gpsdrive"
    "directory. Here is a sample:\n\n"
    "map_stmk.gif          47.08    15.45    300000\n"
    "map_austria.gif       48.0     14.0    1000000\n"
    "map_bruck-m-umgeb.gif 47.44    15.29    100000\n"
    "The first row is the filename, then comes the latitude, the longitude "
    "and the scale of the map. The scale of 10000000 is good for Europe, "
    "and 100000 is for a town like Vienna.\n\n"
    "To get a map you may go to a URL like this:\n\n"
    "http://www.mapblast.com/gif?&CT=51.0:10.0:2500000&IC=&W=1280&H=1024&FAM=mblast&LB=\n\n"
    "This is the latitude -----------^^^^\n"
    "This is the longitude ---------------^^^^\n"
    "This is the scale -----------------------^^^^^^^^\n\n"
    "Take the lat., long. and scale values from your URL and put it into "
    "the map_koord.txt file together with the name of the file.\n\n"
    "GpsDrive selects the map with the best scale for your position. So get"
    "a map i.e for Europe, Austria and Vienna if you want to drive in "
    "Vienna.\n\n"
    "It is also important to leave the size 1280x1024 points like in the "
    "URL above!\n\n"
    "For easy use, I provide the script \"gpsfetchmap\" to get the map from "
    "the internet and make the entry in the map_koord.txt file.\n\n"
    "Usage: \n\n"
    "gpsfetchmap filename latitude longitude scale\n\n"
    "The filename should have the extension .gif.\n\n"
    "EASY USE:\n\n"
    "The same you can do with the \"download map\" button in the program.\n\n"
    "ATTENTION: Mapblast.com maps with a scale greater then 1:2 millions "
    "seems to be have another projection system, GpsDrive shows here a "
    "INCORRECT position! Has anyone information about this?\n\n"
    "*****************************************************\n"
    "Please read the copyright notice of www.mapblast.com!\n"
    "*****************************************************\n"
    "Localisation\n"
    "------------\n\n"
    "If you installed the program it will display messages in english, "
    "german, french, italian or spanish if your language is set either with "
    "LANG or LANGUAGE. LANGUAGE overrides all other settings. Call \"locale\" "
    "to see the settings and call \"set\" if LANG or LANGUAGE is set. For "
    "german do:\n\n"
    "export LANGUAGE=de\n\n"
    "and then call gpsdrive in this shell.\n\n"
    "File formats:\n\n"
    "The decimal points in way.txt must always be a dot ('.'), in "
    "map_koord.txt '.' or ',' are possible. If you download maps from "
    "within the program, GpsDrive writes the map_koord.txt respecting your ttys"
    "LC_NUMERIC setting.\n\n"
    "Can I use other maps?\n"
    "--------------------\n\n"
    "You can also use your own (self drawn, scanned...) maps. The maps must "
    "be gif, jpeg, png or other common file formats (the format must be "
    "recognized by the gdk-pixbuf library).  The lat/long coordinates you "
    "write into the \"map_koord.txt\" file must be the center of the map. The "
    "map must have a size of 1280x1024 pixels! You have to measure and "
    "calculate the scale yourself.\n\n"
    "It is important you use the right filenames. The filenames must start "
    "with \"map_\" for street maps and with \"top_\" for topographic maps.\n\n"
    "Importing waypoints:\n"
    "-------------------\n\n"
    "You should also create a file \"way.txt\" in your ~/.gpsdrive directory "
    "which looks like:\n\n"
    "DEFAULT  47.0792  15.4524\n"
    "KLGNFR   46.6315  14.3152\n"
    "MCDONA   47.0555  15.4488\n\n"
    "The waypoint named \"DEFAULT\" is the start position of the program, "
    "important if you start it in simulation mode. So not everybody in the "
    "world need to start at my house in Austria! ;-) "
    "It is also ok if the waypoint is named DEFAUL because my GARMIN GPS "
    "III stores only 6 charakters for a waypoint.\n\n"
    "The rows are: label latitude longitude.\n\n"
    "If the file doesn't exist or doesn't contain valid data, there is no "
    "\"Goto\" button available.\n\n"
    "You can use the program \"garble\" (included in the package) to read "
    "out your waypoints from the Garmin GPS (Transfer mode must set to "
    "GARMIN here, while GpsDrive needs NMEA!).\n\n"
    "The easier way is to use the script \"wpget\" which does all for you. \n\n"
    "Be sure to have \"wpget\", \"wpcvt\" and \"garble\" in your path.\n\n"
    "Some comments to fonts:\n"
    "----------------------\n\n"
    "GpsDrive is useing the font\n"
    "-monotype-arial-bold-r-normal-*-*-360-*-*-p-*-iso8859-15\n"
    "for the big letters. If this font is not found, it uses\n"
    "-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-15\n"
    "which should be available on a XFree86 installation.\n\n"
    "If you want to change the font, find the define \"FONT1\" in the source"
    "code and replace the font string.\n\n"
    "Speech output:\n"
    "-------------\n\n"
    "If you want speech output you have to install the software \"festival\". "
    "See http://fife.speech.cs.cmu.edu/festival for information. "
    "If you have a functional festival software call it as server with:\n\n"
    "festival --server\n\n"
    "If you start GpsDrive then, it will detect the server on the port 1314 and "
    "puts out some status information as  speech. You also have an "
    "additonal button (Mute) to switch of sound output.\n\n"
    "There is an option -l to switch between languages for speech "
    "output. At the moment english and german are supported. GpsDrive "
    "doesn't set festival into the proper language, you have to do it "
    "yourself. If you wish other language supported, please send me "
    "translations of the texts in gpsdrive.c and speech_out.c, look for the "
    "strings beginning with \"SayText\".\n\n"
    "=======================================================================\n\n"
    "Suggestions welcome!\n\n"
    "Have a lot of fun!\n\n"
    "Fritz Ganter <ganter@ganter.at>\n\n"
    "http://www.kraftvoll.at/software\n\n");

  popup = gtk_dialog_new ();

  gtk_window_set_title (GTK_WINDOW (popup), _("GpsDrive Help"));
  gtk_window_set_default_size (GTK_WINDOW (popup), 550, 450);

  knopf2 = gtk_button_new_with_label (_("   Ok   "));
  gtk_signal_connect_object (GTK_OBJECT (knopf2), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (popup));
  gtk_container_set_border_width (GTK_CONTAINER (popup), 5);
  GTK_WIDGET_SET_FLAGS (knopf2, GTK_CAN_DEFAULT);
  gtk_window_set_default (GTK_WINDOW (popup), knopf2);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->action_area), knopf2,
		      FALSE, FALSE, 20);

  text = gtk_text_new (NULL, NULL);
  gtk_text_set_line_wrap (GTK_TEXT (text), TRUE);
  gtk_text_set_word_wrap (GTK_TEXT (text), TRUE);
  scrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, meintext, -1);
  hbox = gtk_hbox_new (FALSE, 3);
  gtk_box_pack_start (GTK_BOX (hbox), text, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), scrollbar, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->vbox), hbox, TRUE,
		      TRUE, 10);
  gtk_window_set_position (GTK_WINDOW (popup), GTK_WIN_POS_CENTER);
  gtk_widget_show_all (popup);


  return TRUE;

}

