/***********************************************************************

Copyright (c) 2001 Fritz Ganter <ganter@ganter.at>

Website: www.kraftvoll.at

Disclaimer: Please do not use for navigation. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    *********************************************************************

$Log: gpsdrive.c,v $
Revision 1.162  2001/12/02 21:41:44  ganter
fixed bug in setlocale

Revision 1.161  2001/12/02 17:40:37  ganter
friends mode bugfix. Enhanced -x option

Revision 1.160  2001/11/16 20:12:19  ganter
v1.5

Revision 1.159  2001/11/16 18:00:54  ganter
tcpserver/client works

Revision 1.158  2001/11/13 18:37:46  ganter
v1.4 enhanced friends functions

Revision 1.157  2001/11/12 19:55:47  ganter
v1.3

Revision 1.156  2001/11/12 19:11:53  ganter
friends server and client starting to work

Revision 1.155  2001/11/11 17:25:34  ganter
added friendsd

Revision 1.154  2001/11/04 19:38:32  ganter
autodetects setting for voice output, cosmetic changes

Revision 1.153  2001/11/03 23:27:00  ganter
moved manpages to man directory

Revision 1.152  2001/11/03 19:22:07  ganter
next public v1.1, made testnewmap more accurate

Revision 1.151  2001/11/03 19:10:05  ganter
new layout, some buttons are now checkboxes

Revision 1.150  2001/11/03 12:52:12  ganter
v1.1, added best map button and next more/less detailed map button

Revision 1.149  2001/11/02 00:42:32  ganter
real v1.0, changed manpage

Revision 1.148  2001/11/02 00:10:02  ganter
v1.0 for public

Revision 1.147  2001/11/01 20:17:58  ganter
v1.0 added spanish voice output

Revision 1.146  2001/11/01 11:36:39  ganter
added festival init for german and english. See manpage

Revision 1.145  2001/10/29 15:26:20  ganter
added -o

Revision 1.144  2001/10/29 12:43:23  ganter
added -o option to output NMEA sentences. Written by Dan Egnor <egnor@ofb.net>

Revision 1.143  2001/10/28 17:17:38  ganter
v0.35

Revision 1.142  2001/10/28 15:54:56  ganter
v0.35 added load and store track

Revision 1.141  2001/10/27 16:05:03  ganter
autodetected screen size

Revision 1.140  2001/10/26 17:58:09  ganter
added auto detecting screen size

Revision 1.139  2001/10/22 23:37:23  ganter
v 0.34 added proxy server

Revision 1.138  2001/10/21 18:12:51  ganter
v0.33

Revision 1.137  2001/10/21 16:44:10  ganter
bugfix in position calculation for big maps.
pre 0.33

Revision 1.136  2001/10/21 14:38:09  ganter
found buffer overflow in get_position_data_cb only in NMEA mode, result was wrong text translations.

Revision 1.135  2001/10/21 03:06:30  ganter
new position calculation looks good, but in progress...

Revision 1.134  2001/10/19 23:30:11  ganter
track parts are not drawn if no GPS Fix is avail. Should work...

Revision 1.133  2001/10/16 14:11:40  ganter
added po files

Revision 1.132  2001/10/14 14:35:38  ganter
really V0.32 expedia server works now

Revision 1.131  2001/10/14 13:09:11  ganter
working on expedia scaling

Revision 1.130  2001/10/14 11:26:04  ganter
Program now creates a ~/.gpsdrive directory if it was not found. Also
it creates a map_koord.txt in it.

Revision 1.129  2001/10/14 10:41:59  ganter
v0.32 correct path for prefix other than /usr/local

Revision 1.128  2001/10/13 23:04:56  ganter
corrected paths for locale and pixmap, ./configure --prefix= works now as
expected

Revision 1.127  2001/10/13 15:33:18  ganter
test

Revision 1.126  2001/10/09 13:14:02  ganter
v0.31

Revision 1.125  2001/10/08 23:36:17  ganter
added download from expedia.com, but it don't work yet.
Reason: Server don't send CONTENT-LENGTH

Revision 1.124  2001/10/08 12:14:05  ganter
radar detection stopped working, runs now again

Revision 1.123  2001/10/08 02:24:39  ganter
fixed bug in testconfig_cb

Revision 1.122  2001/10/07 20:06:08  ganter
detects wrong names in map_koord.txt

Revision 1.121  2001/10/07 16:30:09  ganter
v0.30

Revision 1.120  2001/10/07 15:19:55  ganter
removed some debugging lines

Revision 1.119  2001/10/07 15:17:29  ganter
import seems to work

Revision 1.118  2001/10/07 00:59:13  ganter
map import nearly finished

Revision 1.117  2001/10/04 19:26:59  ganter
added rectangle on minimap
working on map import

Revision 1.116  2001/09/30 18:45:27  ganter
v0.29
added choice of map type

Revision 1.115  2001/09/30 15:54:32  ganter
added minimap, removed gpsdrivelogo

Revision 1.114  2001/09/30 12:08:11  ganter
added parameter -x to use a seperate window for the menu
some changes in speech output
added help button

Revision 1.113  2001/09/28 15:43:56  ganter
v0.28 changed layout, some bugfixes

Revision 1.112  2001/09/27 16:52:29  ganter
...

Revision 1.111  2001/09/25 23:49:43  ganter
v 0.27

Revision 1.110  2001/09/25 23:32:59  ganter
some bugfixes for tracking

Revision 1.109  2001/09/25 20:58:13  ganter
tracking is working

Revision 1.108  2001/09/25 17:00:32  ganter
fallback font strings corrected

Revision 1.107  2001/09/24 19:42:20  ganter
removed -s -g -f command line options. GpsDrive tries first port 2222,
then port 2947 and if not found the GARMIN mode. If this is also not
found it switches to simulation mode.

Revision 1.106  2001/09/24 19:00:46  ganter
added support for gpsd by  Remco Treffkorn using port 2947

Revision 1.105  2001/09/23 22:31:13  ganter
v0.26

Revision 1.104  2001/09/23 22:04:03  ganter
Added -t and -l command line switches, see gpsdrive -h
Added german speech texts.
Bugfix in radar detection. Only the nearest Radar gives speech output.
Cosmetic changes for markers.
#define MAXSHOWNWP 100 for max. shown waypoints. Tested with list of
30000 waypoints. If gpsdrive hangs, reduce number of waypoints in
file.
Better fallbacks for fonts. I prefer an arial truetype font. Helvetica
is used if no arial font is found.

Revision 1.103  2001/09/23 15:06:32  ganter
...

Revision 1.102  2001/09/23 00:58:59  ganter
...

Revision 1.101  2001/09/22 23:35:00  ganter
Added program icon. Added check for way.txt format errors.

Revision 1.100  2001/09/22 16:22:47  ganter
solved this intl compile problem

Revision 1.99  2001/09/21 23:16:20  ganter
v0.25

Revision 1.98  2001/09/21 23:11:07  ganter
added error message for not existent DEFAULT waypoint
added popup error window

Revision 1.97  2001/09/21 21:32:20  ganter
In the way.txt waypoint file the waypoint
named "DEFAULT" is the start position of the program,
important if you start it in simulation mode.
So not everybody in the world need to start at my
house in Austria! ;-)
Bugfix if at start no map is found.

Revision 1.96  2001/09/21 10:47:06  ganter
V0.24: bugfix for displays which have not 16 bit colordepth

Revision 1.95  2001/09/20 15:07:44  ganter
added Radar warning. If you store the radars as waypoints named R-XXXX where
XXXX can be a incremented number. You hear radar warning as voice message and
a red/black blinking Bearing pointer.

Revision 1.94  2001/09/18 23:02:03  ganter
v0.22

Revision 1.93  2001/09/18 22:56:10  ganter
If you click with the left mouse button on the map you are in "Display
mode" where a rectangle is the cursor and no position is shown. If you
zoom or select another map scale, this is done for the position of the
rectangle-cursor in the same manner as it would be your actual
position.

The middle mouse button switches back to normal mode. The same if you
select a target with the right mouse button.  Shift-left-mouse-button
and shift-right-mouse-button changes the map scale.

Revision 1.92  2001/09/18 21:44:42  ganter
testnewmap is not o.k.

Revision 1.91  2001/09/18 13:40:13  ganter
v0.21 using double buffering to avoid flicker.

Revision 1.90  2001/09/18 05:33:06  ganter
..

Revision 1.89  2001/09/17 19:03:54  ganter
changed speech text

Revision 1.88  2001/09/17 00:29:38  ganter
added speech output of bearing

Revision 1.87  2001/09/16 21:36:05  ganter
speech output is working

Revision 1.86  2001/09/16 19:12:35  ganter
...

Revision 1.84  2001/09/16 18:42:32  ganter
now we work on speech output

Revision 1.83  2001/09/09 17:31:36  ganter
v0.18 added defines to make it possible to define smaller screen sizes
this is the way to porting for iPaq

Revision 1.82  2001/09/09 15:30:39  ganter
numbers changed to SCREEN_X and SCREEN_Y, but doesn't work yet

Revision 1.81  2001/09/09 14:54:44  ganter
beginning rewrite source to set screenwidth and height as define

Revision 1.80  2001/09/09 08:07:11  ganter
v0.17

Revision 1.79  2001/09/08 18:49:11  ganter
added + sign as marker for the selected target

Revision 1.78  2001/09/08 13:20:58  ganter
added tooltips

Revision 1.77  2001/09/06 22:00:53  ganter
added: click with right mouse button on map sets the target waypoint

Revision 1.76  2001/09/06 12:19:43  ganter
changed strings

Revision 1.75  2001/09/06 08:51:57  ganter
changed label order, now really v0.15

Revision 1.74  2001/09/06 08:46:35  ganter
some string changes, really v0.15

Revision 1.73  2001/09/06 00:16:02  ganter
display_status

Revision 1.72  2001/09/06 00:05:50  ganter
new fields layout

Revision 1.71  2001/09/05 22:03:26  ganter
scaler works

Revision 1.70  2001/09/05 19:33:06  ganter
created scaler for map scale selection

Revision 1.69  2001/09/04 22:15:59  ganter
...

Revision 1.68  2001/09/04 21:30:48  ganter
added time to destination. I didn't calculate with bearing.

Revision 1.67  2001/09/04 19:55:40  ganter
moved progress bar into the download window
download window is only removed after download
added delete_event handler for download_cb

Revision 1.66  2001/09/04 12:43:15  ganter
added progress bar for download status

Revision 1.65  2001/09/04 01:20:23  ganter
restore cursor on end of download

Revision 1.64  2001/09/04 00:39:57  ganter
added cool cursor for map position selection

Revision 1.63  2001/09/03 23:51:11  ganter
...

Revision 1.62  2001/09/03 23:48:16  ganter
translations

Revision 1.61  2001/09/03 23:32:34  ganter
public v0.13

Revision 1.60  2001/09/03 23:04:53  ganter
map is now clickable for selection of the download position.
yardstick is fixed for m/yards display.

Revision 1.59  2001/09/03 15:42:56  ganter
missing translation

Revision 1.58  2001/09/03 15:36:39  ganter
added scale marker on map

Revision 1.57  2001/09/03 01:20:32  ganter
added scale line, it's not perfect yet

Revision 1.56  2001/09/02 18:48:11  ganter
near to v0.12

Revision 1.55  2001/09/02 17:09:32  ganter
download of gif doesn't work correctly sometimes

Revision 1.54  2001/09/02 14:39:15  ganter
...

Revision 1.53  2001/09/01 18:15:57  ganter
download in a non-blocking timeout routine

Revision 1.52  2001/09/01 15:50:43  ganter
working on downloading maps from internet

Revision 1.51  2001/08/31 19:53:48  ganter
rearranged calls of draw_marker.
fixed little bug in zoom-out, works now like expected.

Revision 1.50  2001/08/31 09:56:11  ganter
fixed bug if you are West or South. Thanks to Jason Aras.

Revision 1.49  2001/08/31 01:29:43  ganter
version 0.10

Revision 1.48  2001/08/30 01:24:43  ganter
better simulator

Revision 1.47  2001/08/30 00:08:01  ganter
more beautifully indent. Thanks to timecop@japan.co.jp

Revision 1.46  2001/08/29 23:13:44  ganter
version 0.9

Revision 1.45  2001/08/29 21:58:13  ganter
code cleanup, translated to english

Revision 1.44  2001/08/29 19:07:08  ganter
main() code rewritten for better readability because japanese people
complained about bad style coding.
Also translate all variable and messages to english.

Revision 1.43  2001/08/29 14:00:42  ganter
changed variable names to english

Revision 1.42  2001/08/27 21:40:46  ganter
get groundspeed to zero if no movement

Revision 1.41  2001/08/27 13:24:37  ganter
bugfix: . or , should be set depending on  LC_NUMERIC

Revision 1.40  2001/08/27 02:57:18  ganter
Version 0.7

Revision 1.39  2001/08/27 01:03:24  ganter
Version 0.7 added experimental -f flag for direct use of GARMIN format
no gpsd must be started!

Revision 1.38  2001/08/26 23:40:10  ganter
added garble sources to included in gpsdrive

Revision 1.37  2001/08/26 19:33:45  ganter
indent

Revision 1.36  2001/08/26 19:31:53  ganter
"distance to" frame label shows target name

Revision 1.35  2001/08/26 17:46:57  ganter
changed usage, still v0.6

Revision 1.34  2001/08/26 17:38:12  ganter
Version 0.6

Revision 1.33  2001/08/26 17:24:09  ganter
added big zoom field, set refresh rate to 500ms

Revision 1.32  2001/08/26 15:49:40  ganter
indent

Revision 1.31  2001/08/26 15:47:45  ganter
added splash(), coooool!

Revision 1.30  2001/08/25 13:39:33  ganter
*** empty log message ***

Revision 1.29  2001/08/25 12:53:09  ganter
pre v0.5

Revision 1.28  2001/08/25 08:56:53  ganter
added frames for fields

Revision 1.27  2001/08/24 21:34:43  ganter
simulator mode: pointer moves to selected destination

Revision 1.26  2001/08/24 16:56:17  ganter
working on satellites

Revision 1.25  2001/08/24 09:58:57  ganter
course pointer is something ugly

Revision 1.24  2001/08/24 00:25:29  ganter
corrected angel values, 0 is on top (north) and angel is counting clockwise

Revision 1.23  2001/08/23 00:08:11  ganter
added pointer to destination

Revision 1.22  2001/08/22 09:31:37  ganter
changes to way.txt handling

Revision 1.21  2001/08/22 08:45:58  ganter
version 0.4 for public

Revision 1.20  2001/08/22 00:10:19  ganter
distance measurment adjusted

Revision 1.19  2001/08/21 23:19:00  ganter
destination selection added

Revision 1.18  2001/08/20 15:35:45  ganter
little bug in zoom out found, xoff and yoff was not updated.

Revision 1.17  2001/08/19 16:17:08  ganter
Version 0.3 ready for public

Revision 1.16  2001/08/19 15:17:31  ganter
some cleanups

Revision 1.15  2001/08/19 14:26:19  ganter
fixed offset=0 when new map loaded.

Revision 1.14  2001/08/19 13:55:01  ganter
found this little bug (x instead of y in line 469).
Am I too old for programming?

Revision 1.13  2001/08/19 11:58:44  ganter
there is only a big bug in the y direction.

Revision 1.12  2001/08/19 00:34:01  ganter
working hard on zooming...

Revision 1.11  2001/08/18 20:28:02  ganter
working on zooming

Revision 1.10  2001/08/18 15:35:03  ganter
added command line options

Revision 1.9  2001/08/18 03:58:12  ganter
map switching works (theroretical, I need a testdrive, now at 6.00am localtime)

Revision 1.8  2001/08/18 00:08:12  ganter
"big" image is working, simulated_pos() simulates moving of map.

Revision 1.7  2001/08/16 23:17:42  ganter
displaying position on map is working and tested through test drive ;-)

Revision 1.6  2001/08/16 20:03:49  ganter
should work

Revision 1.5  2001/08/15 22:39:45  ganter
new version

Revision 1.4  2001/08/15 12:06:03  ganter
data conversion for statusline works

Revision 1.3  2001/08/15 00:45:24  ganter
get GPS data and display in statusbar is working

Revision 1.2  2001/08/14 18:53:37  ganter
first version running

Revision 1.1.1.1  2001/08/14 13:52:20  ganter
gpsdrive started

***********************************************************************/

/*  Include Dateien */
#include "../config.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
#include <math.h>
#include <sys/time.h>
#include "gtk/gtk.h"
#include "gdk-pixbuf/gdk-pixbuf.h"
#include <locale.h>
#include "stop.h"
#include "gpsico.h"

/*  Defines for gettext I18n */
# include <libintl.h>
# define _(String) gettext(String)
# ifdef gettext_noop
#  define N_(String) gettext_noop(String)
# else
#  define N_(String) (String)
# endif

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/*  adapt this section for the size of your screen */

/*  width of the map on screen, default is 640 */
#define SCREEN_X real_screen_x
/*  height of the map on screen, default is 512 */
#define SCREEN_Y real_screen_y
#define FONTBIG "-monotype-arial-bold-r-normal-*-*-360-*-*-p-*-iso8859-1"
#define FONTSMALL "-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1"
#define FONTTINY "-monotype-arial-bold-r-normal-*-*-140-*-*-p-*-iso8859-1"
#define FONTTINY2 "-adobe-helvetica-bold-r-normal-*-*-140-*-*-p-*-iso8859-1"
#define TEXTFONT "-monotype-arial-bold-r-normal-*-*-160-*-*-p-*-iso8859-1"
#define TEXTFONT2 "-adobe-helvetica-bold-r-normal-*-*-140-*-*-p-*-iso8859-1"
#define SMALLTEXTFONT "-monotype-arial-medium-r-normal-*-*-120-*-*-p-*-iso8859-1"
#define SMALLTEXTFONT2 "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1"

#define FONT1 FONTBIG
#define FONT2 FONTSMALL

/*  set this to 0 for normal use, 1 for small screens */
#define SMALLMENU real_smallmenu

/*  size of the bearing pointer, default is 50 */
#define PSIZE real_psize

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/




#define MAXBIG 50000

/*  How oft do we redraw the screen (in milliseconds) */
#define REDRAWTIMER 300
/*  How often do we ask for positioning data */
#define TIMER 500

#define MAXSHOWNWP 100

/*  timer for watching waypoints (Radar) */
#define WATCHWPTIMER 2000

/*  If speech output is used, the intervall of spoken messages in milliseconds */
#define SPEECHOUTINTERVAL 10000

/*  Pixel to border before shifting map */
#define BORDERLIMIT SCREEN_X/10


#define SERVERNAME "localhost"
#define SERVERPORT 2222
#define SERVERPORT2 2947

#define WANTSHADOWNO

#define MAPSCALE 20000
/* Mapscale / pixelfact is meter / pixel */
#define PIXELFACT 2817.947378
#define KM2MILES 0.62137119


#define LOCALTESTXXX
#ifdef LOCALTEST
#define WEBSERVER "wuffi.grazforyou.at"
#else
#define WEBSERVER "www.mapblast.com"
#endif
#define WEBSERVER2 "msrvmaps.expedia.com"

#define FESTIVAL_ENGLISH_INIT "(voice_ked_diphone)"
#define FESTIVAL_GERMAN_INIT "(voice_german_de3_os)"
#define FESTIVAL_SPANISH_INIT "(voice_el_diphone)"

#define EXPEDIAFACT 1378.6

/*  global variables */
gint statusid, timeoutcount;
GtkWidget *mainwindow, *status, *pixmapwidget, *gotowindow;
extern GtkWidget *splash_window;
gint sock, dlsock, bigp, bigpGSV, lastp, lastpGSV, debug;
FILE *nmeaout = NULL;
gchar *buffer, *big;
fd_set readmask, friendsreadmask;
struct timeval timeout, friendstimeout;
gchar targetname[40];
gdouble current_long, current_lat, old_long, old_lat, groundspeed;
gdouble zero_long, zero_lat, target_long, target_lat, dist;
gdouble long_diff = 0, lat_diff = 0;
GdkGC *kontext;
GdkColor red = { 0, 0xFF00, 0x00, 0x00 };
GdkColor black = { 0, 0x00, 0x00, 0x00 };
GdkColor white = { 0, 0xFFFF, 0xFFFF, 0xFFFF };
GdkColor blue = { 0, 0x00, 0x00, 0xff00 };
GdkColor yellow = { 0, 0xff00, 0xbf00, 0x00 };
GdkColor green = { 0, 0x0300, 0x4000, 0xbc00 };
GdkColor mygray = { 0, 0xd500, 0xd600, 0xd500 };
GdkColor darkgrey = { 0, 0xb500, 0xb600, 0xb500 };
GtkWidget *drawing_area, *drawing_area2, *drawing_area3, *drawing_area4;
GtkWidget *distlabel, *speedlabel, *zoomlabel, *miles;
GdkDrawable *drawable, *drawable2, *drawable3;
gint havepos, haveposcount, blink, gblink, xoff, yoff, crosstoogle = 0;
gdouble pixelfact, posx, posy, angel_to_destination, direction, bearing;
GdkPixbuf *image, *friendsimage, *tempimage, *friendspixbuf, *miniimage =
  NULL;
typedef struct
{
  gchar filename[200];
  gdouble lat;
  gdouble longitude;
  glong scale;
}
mapsstruct;
mapsstruct *maps;
typedef struct
{
  gchar name[40];
  gdouble lat;
  gdouble longitude;
  gdouble dist;
}
wpstruct;
wpstruct *wayp;

typedef struct
{
  gchar name[40];
  gdouble lat;
  gdouble longitude;
}
friendsstruct;
friendsstruct *friends;



gchar *dlpstart;
gchar oldfilename[200];
GString *tempmapfile;
gint nrmaps, dldiff;
gdouble earthr;
/*Earth radius calibrated with GARMIN III */
/*  gdouble R = 6383254.445; */


#define R earthr


/*  if we get data from gpsd in NMEA format haveNMEA is TRUE */
/*  haveGARMIN is TRUE if we get data from program garble in GARMIN we get only long and lat */
gint haveNMEA, haveGARMIN;

gint maploaded, simmode, zoom, iszoomed;
gchar homedir[200];
static gchar const rcsid[] =
  "$Id: gpsdrive.c,v 1.162 2001/12/02 21:41:44 ganter Exp $";
gint thisline;
gint maxwp, maxfriends = 0;
GtkStyle *style = NULL;
gint satlist[40][2], satlistdisp[40][2], satbit = 0;
GtkWidget *mylist, *destframe;
gchar mapfilename[200];
gdouble gbreit, glang, milesconv, olddist = 99999.0;
GTimer *timer, *disttimer;
gint gcount, milesflag, downloadwindowactive;
struct lconv *mylocale;
gchar *dlbuff, downloadfilename[512];
gint scaleprefered = 1, scalewanted = 100000;
gint dlcount, downloadactive, importactive, downloadfilelen;
glong mapscale;
GtkWidget *dltext1, *dltext2, *dltext3, *dltext4;
GtkWidget *dltext5, *dltext6, *dltext7, *myprogress;
GtkWidget *scaler, *downloadwindow;
gchar writebuff[300];
gchar newmaplat[100], newmaplongi[100], newmapsc[100], oldangel[100];
GdkFont *textfont, *smalltextfont;
GdkCursor *cursor;
gchar *slist[] = { "1000", "1500", "2000", "3000", "5000", "7500",
  "10000", "15000", "20000", "30000", "50000", "75000",
  "100000", "150000", "200000", "300000", "500000", "750000",
  "1000000", "1500000", "2000000", "3000000", "5000000", "7500000",
  "10000000", "15000000", "20000000", "30000000", "50000000", "75000000"
};
gint nlist[] = { 1000, 1500, 2000, 3000, 5000, 7500,
  10000, 15000, 20000, 30000, 50000, 75000,
  100000, 150000, 200000, 300000, 500000, 750000,
  1000000, 1500000, 2000000, 3000000, 5000000, 7500000,
  10000000, 15000000, 20000000, 30000000, 50000000, 75000000
};
GtkWidget *l1, *l2, *l3, *l4, *l5, *l6, *l7, *l8, *mutebt, *trackbt, *wpbt;
GtkWidget *bestmapbt, *maptogglebt, *topotogglebt, *savetrackbt;
GtkWidget *importbt, *loadtrackbt, *radio1, *radio2, *scalerlbt, *scalerrbt;
gint savetrack = 0, havespeechout, hours, minutes, speechcount = 0;
gint muteflag = 0, trackflag = 0, wpflag = 0;
gint displaymap_top = FALSE, displaymap_map = FALSE;
gint posmode = 0;
gdouble posmode_x, posmode_y;
GtkObject *adj;
gchar lastradar[40], lastradar2[40], nmeamodeandport[50], importfilename[80];
gint foundradar, messageshown = FALSE, havedefaultpos = FALSE;
gdouble radarbearing;
gint errortextmode = TRUE;
enum
{ english, german, spanish }
voicelang;
gchar serialdev[80];
typedef struct
{
  gint16 x;
  gint16 y;
}
trackstruct;

trackstruct *track;
glong tracknr;
typedef struct
{
  gdouble longi;
  gdouble lat;
  gchar postime[30];
}
trackcoordstruct;
trackcoordstruct *trackcoord;
glong trackcoordnr, tracklimit, trackcoordlimit;
gint extrawinmenu = FALSE, expedia = FALSE;
typedef struct
{
  gdouble lon;
  gdouble lat;
  gint x;
  gint y;
}
impstruct;
impstruct imports[3];
gdouble Ra[201];
gint haveproxy, proxyport;
gchar proxy[256], hostname[256], savetrackfn[256];
gint real_screen_x, real_screen_y, real_psize, real_smallmenu;
gint SCREEN_X_2, SCREEN_Y_2;
gint wrongwplist = 0;
extern gint havefriends;
extern gint friendssock;
extern gchar friendsserver[];
gchar *friendsbuffer, friendsname[200];
gchar *friendsbuffstart, *friendsbuffend;
gchar friendstxt[1000][200], friendslat[1000][20], friendslon[1000][20];
gchar friendstim[1000][20], friendsspeed[1000][20], friendsdir[1000][20];

/*  Prototypes */
void loadmap (char *filename);
gint zoom_cb (GtkWidget *widget, guint datum);
void splash (void);
int garblemain (int argc, char **argv);
void display_status (char *message);
gint drawmarker (GtkWidget *widget, guint *datum);
gint downloadslave_cb (GtkWidget *widget, guint datum);
gint downloadstart_cb (GtkWidget *widget, guint datum);
gint downloadsetparm (GtkWidget *widget, guint datum);
void savemapconfig ();
void loadmapconfig ();
void loadwaypoints ();
extern gint speech_out_speek (char *text);
extern gint speech_out_init ();
gdouble calcdist (gdouble longi, gdouble lati);
gdouble calcdist2 (gdouble longi, gdouble lati);
gint speech_saytime_cb (GtkWidget *widget, guint datum);
gint help_cb (GtkWidget *widget, guint datum);
gint sel_target_cb (GtkWidget *widget, guint datum);
gint import1_cb (GtkWidget *widget, guint datum);
void savetrackfile (gint testname);
void rebuildtracklist (void);
void openfriendsport (void);
gint friendsagent_cb (GtkWidget *widget, guint *datum);

/*  quit the program */
gint
quit_program (GtkWidget *widget, gpointer datum)
{
  gtk_main_quit ();
  g_mem_profile ();
  if (savetrack)
    savetrackfile (FALSE);
  return (TRUE);
}

gint
error_popup (gpointer datum)
{
  GtkWidget *popup;
  GtkWidget *knopf2;
  GtkWidget *knopf3;
  GdkPixmap *fritzpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmapwidget;

  if (errortextmode)
    {
      g_print ("\nError: %s\n", (char *) datum);
      return (FALSE);
    }
  popup = gtk_dialog_new ();
  fritzpixmap =
    gdk_pixmap_create_from_xpm_d (mainwindow->window, &mask, NULL, stop);

  pixmapwidget = gtk_pixmap_new (fritzpixmap, mask);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->vbox), pixmapwidget,
		      FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (popup), 5);

  gtk_window_set_title (GTK_WINDOW (popup), _("  Message  "));
  knopf2 = gtk_button_new_with_label (_("Ok"));
  GTK_WIDGET_SET_FLAGS (knopf2, GTK_HAS_FOCUS);

  gtk_signal_connect_object (GTK_OBJECT (knopf2), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (popup));


  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->action_area), knopf2, TRUE,
		      TRUE, 20);
  knopf3 = gtk_label_new (datum);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->vbox), knopf3, FALSE,
		      FALSE, 10);


  gtk_window_set_position (GTK_WINDOW (popup), GTK_WIN_POS_CENTER);
  gtk_widget_show (pixmapwidget);
  gtk_widget_show (knopf2);
  gtk_widget_show (knopf3);
  gtk_widget_show (popup);

  return (FALSE);

}


gdouble
calcR (gdouble lat)
{
  gdouble a = 6378.137, r, sc, x, y, z;
  gdouble e2 = 0.081082 * 0.081082;
/*
the radius of curvature of an ellipsoidal Earth in the plane of the 
meridian is given by 

 R' = a * (1 - e^2) / (1 - e^2 * (sin(lat))^2)^(3/2) 

 where a is the equatorial radius, 
b is the polar radius, and 
e is the eccentricity of the ellipsoid = sqrt(1 - b^2/a^2) 

a = 6378 km (3963 mi) Equatorial radius (surface to center distance) 
b = 6356.752 km (3950 mi) Polar radius (surface to center distance) 
e = 0.081082 Eccentricity 
*/

  lat = lat * M_PI / 180.0;
  sc = sin (lat);
  x = a * (1.0 - e2);
  z = 1.0 - e2 * sc * sc;
  y = pow (z, 1.5);
  r = x / y;

  r = r * 1000.0;
/*      g_print("\nR=%f",r); */
  return r;
}

void
calcxy (gdouble *posx, gdouble *posy, gdouble lon, gdouble lat, gint zoom)
{
  gdouble dif;

  *posx =
    (Ra[(int) (100 + lat)] * M_PI / 180.0) * cos (M_PI * lat / 180.0) * (lon -
									 zero_long);
  *posx = SCREEN_X_2 + *posx * zoom / pixelfact;
  *posx = *posx - xoff;

  *posy = (Ra[(int) (100 + lat)] * M_PI / 180.0) * (lat - zero_lat);
  dif =
    Ra[(int) (100 + lat)] * (1 - (cos ((M_PI * (lon - zero_long)) / 180.0)));
  *posy = *posy + dif / 1.85;
  *posy = SCREEN_Y_2 - *posy * zoom / pixelfact;
  *posy = *posy - yoff;
}


void
convertRMC (char *f)
{
  gchar field[20][100], b[100];
  gint i, j = 0, start = 0;
  gint longdegree, latdegree;
  gchar langri, breitri;

  memset (b, 0, 100);

/*  if simulation mode we display status and return */
  if (simmode && maploaded && !posmode)
    {
      display_status (_("Simulation mode"));
      return;
    }

/*  get fields delimited with ',' */
  for (i = 0; i < strlen (f); i++)
    {
      if (f[i] == ',')
	{
	  strcpy (field[j], (f + start));
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    for (i = 0; i < j; i++)
      g_print ("\n%d:%s", i, field[i]);

  sprintf (b, "%c%c:%c%c.%c%c ", field[1][0], field[1][1], field[1][2],
	   field[1][3], field[1][4], field[1][5]);
  strcpy (f, b);
  strcat (f, _("UTC "));
  if (field[2][0] != 'A')
    {
      havepos = FALSE;
      haveposcount = 0;
      return;
    }
  else
    {
      havepos = TRUE;
      haveposcount++;
      if (haveposcount == 3)
	rebuildtracklist ();
    }
/*  Latitude North / South */
  b[0] = field[3][0];
  b[1] = field[3][1];
  b[2] = 0;
  latdegree = atoi (b);


  b[0] = field[3][2];
  b[1] = field[3][3];
  b[2] = (char) mylocale->decimal_point[0];	// field[3][4];
  b[3] = field[3][5];
  b[4] = field[3][6];
  b[5] = field[3][7];
  b[6] = 0;
  current_lat = latdegree + atof (b) / 60.0;
  if (field[4][0] == 'S')
    current_lat = current_lat * -1;

  breitri = field[4][0];
  sprintf (b, " %8.5f%c", current_lat, breitri);
  strcat (f, b);

/*  Longitude East / West */
  b[0] = field[5][0];
  b[1] = field[5][1];
  b[2] = field[5][2];
  b[3] = 0;
  longdegree = atoi (b);

  b[0] = field[5][3];
  b[1] = field[5][4];
  b[2] = (char) mylocale->decimal_point[0];	// field[3][4];
  b[3] = field[5][6];
  b[4] = field[5][7];
  b[5] = field[5][8];
  b[6] = 0;

  current_long = longdegree + atof (b) / 60.0;
  if (field[6][0] == 'W')
    current_long = current_long * -1;

  langri = field[6][0];
  sprintf (b, " %8.5f%c", current_long, langri);

  strcat (f, b);

/*  speed */
  b[0] = field[7][0];
  b[1] = field[7][1];
  b[2] = field[7][2];
  b[3] = (char) mylocale->decimal_point[0];	// field[3][4];
  b[4] = field[7][4];
  b[5] = 0;
  groundspeed = atof (b) * 1.852 * milesconv;
  sprintf (b, " %s: %s", _("Map"), mapfilename);
  strcat (f, b);
/*    g_print("Field %s\n",field[8]); */
  b[0] = field[8][0];
  b[1] = field[8][1];
  b[2] = field[8][2];
  b[3] = (char) mylocale->decimal_point[0];	// field[3][4];
  b[4] = field[8][4];
  b[5] = 0;
/*  direction is the course we are driving */
  direction = atof (b);
  direction = direction * M_PI / 180;
}

/*  show satellites signal level */
void
convertGSV (char *f)
{
  gchar field[20][100], b[500];
  gint i, i2, j = 0, start = 0, n, db, anz;

  memset (b, 0, 100);

  for (i = 0; i < strlen (f); i++)
    {
      if ((f[i] == ',') || (f[i] == '*'))
	{
	  strcpy (field[j], (f + start));
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    {
      g_print ("\nGSV Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("%d:%s$", i, field[i]);
    }
  if (field[2][0] == '1')
    satbit = satbit | 1;
  if (field[2][0] == '2')
    satbit = satbit | 2;
  if (field[2][0] == '3')
    satbit = satbit | 4;

  anz = atoi (field[3]);
  b[0] = field[1][0];
  b[1] = 0;
  i2 = atof (b);
  if (debug)
    g_print ("\nbits should be:%d  is: %d", i2, satbit);
  sprintf (b, "\nSatellites: %d ", anz);
  strcpy (f, b);
  for (i = 4; i < j; i += 4)
    {
      n = atoi (field[i]);
      db = atoi (field[i + 3]);
/*        sprintf (b, "% 2d:% 2ddb", n, db); */
/*        strcat (f, b); */
      satlist[n][0] = n;
      satlist[n][1] = db;
    }

  if (((pow (2, i2)) - 1) == satbit)
    {

      for (i = 0; i < 40; i++)
	if (satlist[i][0] != 0)
	  {
	    sprintf (b, "% 2d: % 2ddb   ", satlist[i][0], satlist[i][1]);
	    strcat (f, b);
	  }
      strcat (f, "***\n");
      if (debug)
	g_print (f);
      satbit = 0;
      memcpy (satlistdisp, satlist, sizeof (satlist));
      memset (satlist, 0, sizeof (satlist));

    }
}

void
display_status (char *message)
{
  gchar tok[200];

  if (downloadactive == TRUE)
    return;
  if (importactive == TRUE)
    return;

  sprintf (tok, "%s", message);
  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
  gtk_statusbar_push (GTK_STATUSBAR (status), statusid, tok);
}

gint
speech_out_cb (GtkWidget *widget, guint *datum)
{
  gchar buf[500], s2[100];
  gint angel;

  if (muteflag)
    return TRUE;
  if (foundradar)
    return TRUE;
  if (importactive)
    return TRUE;


  speechcount++;
  angel = bearing * 180.0 / M_PI;

  if (!simmode && !havepos)
    {
      switch (voicelang)
	{
	case english:
	  sprintf (buf, "(SayText \"No GPS Fix found\")\n");
	  break;
	case spanish:
	  sprintf (buf, "(SayText \"El GPS Fix no est disponible\")\n");
	  break;
	case german:
	  sprintf (buf, "(SayText \"Kein GPS Fix gefunden\")\n");
	}
      if (speechcount == 1)
	speech_out_speek (buf);
      return TRUE;
    }


  switch (voicelang)
    {
    case english:
      if ((angel >= 338) || (angel < 22))
	strcpy (s2, "in front of you");
      if ((angel >= 22) && (angel < 68))
	strcpy (s2, "is ahead of you to the right");
      if ((angel >= 68) && (angel < 112))
	strcpy (s2, "to your right");
      if ((angel >= 112) && (angel < 158))
	strcpy (s2, "behind you to the right");
      if ((angel >= 158) && (angel < 202))
	strcpy (s2, "behind you");
      if ((angel >= 202) && (angel < 248))
	strcpy (s2, "behind you to the left");
      if ((angel >= 248) && (angel < 292))
	strcpy (s2, "to your left");
      if ((angel >= 292) && (angel < 338))
	strcpy (s2, "ahead of you to the left");
      break;
    case spanish:
      if ((angel >= 338) || (angel < 22))
	strcpy (s2, "delante de usted");
      if ((angel >= 22) && (angel < 68))
	strcpy (s2, "delante de usted a la derecha");
      if ((angel >= 68) && (angel < 112))
	strcpy (s2, "a la derecha");
      if ((angel >= 112) && (angel < 158))
	strcpy (s2, "de tras de usted a la derecha");
      if ((angel >= 158) && (angel < 202))
	strcpy (s2, "de tras de usted");
      if ((angel >= 202) && (angel < 248))
	strcpy (s2, "de tras de usted a la izquierda");
      if ((angel >= 248) && (angel < 292))
	strcpy (s2, "a la izquierda");
      if ((angel >= 292) && (angel < 338))
	strcpy (s2, "delante de usted a la izquierda");
      break;
    case german:
      if ((angel >= 338) || (angel < 22))
	strcpy (s2, "vor ihnen");

      if ((angel >= 22) && (angel < 68))
	strcpy (s2, "rechts vor ihnen");
      if ((angel >= 68) && (angel < 112))
	strcpy (s2, "rechts");
      if ((angel >= 112) && (angel < 158))
	strcpy (s2, "rechts hinter ihnen");
      if ((angel >= 158) && (angel < 202))
	strcpy (s2, "hinter ihnen");
      if ((angel >= 202) && (angel < 248))
	strcpy (s2, "links hinter ihnen");
      if ((angel >= 248) && (angel < 292))
	strcpy (s2, "links");
      if ((angel >= 292) && (angel < 338))
	strcpy (s2, "links vor ihnen");
    }
  if ((speechcount == 1) || (strcmp (s2, oldangel)))
    {
      switch (voicelang)
	{
	case english:
	  sprintf (buf, "(SayText \"Destination is %s\")\n", s2);
	  break;
	case spanish:
	  sprintf (buf, "(SayText \"Su destinacin est %s\")\n", s2);
	  break;
	case german:
	  sprintf (buf, "(SayText \"Das Ziel ist %s\")\n", s2);
	}
      speech_out_speek (buf);
      strcpy (oldangel, s2);
    }
  if (speechcount == 3)
    {
      switch (voicelang)
	{
	case english:
	  if (milesflag)
	    sprintf (buf,
		     "(SayText \"The current speed is %d miles per hour\")\n",
		     (int) (groundspeed));
	  else
	    sprintf (buf,
		     "(SayText \"The current speed is %d kilometers per hour\")\n",
		     (int) groundspeed);
	  break;
	case spanish:
	  if (milesflag)
	    sprintf (buf,
		     "(SayText \"La velocidad actual es %d milla por hora\")\n",
		     (int) (groundspeed));
	  else
	    sprintf (buf,
		     "(SayText \"La velocidad actual es %d kilometros por hora\")\n",
		     (int) groundspeed);
	  break;
	case german:
	  if (milesflag)
	    sprintf (buf,
		     "(SayText \"Die momentane Geschwindigkeit ist %d Meilen pro Stunde\")\n",
		     (int) (groundspeed));
	  else
	    sprintf (buf,
		     "(SayText \"Die momentane Geschwindigkeit ist %d kmh\")\n",
		     (int) groundspeed);
	}
      speech_out_speek (buf);
    }

  if (speechcount > 16)
    speechcount = 0;


  if ((speechcount == 2) || ((dist < 1.2) && (speechcount == 8)))
    {
      if (milesflag)
	{
	  switch (voicelang)
	    {
	    case english:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f yards", dist * 1760.0);
	      else
		sprintf (s2, "%.0f miles", dist);
	      break;
	    case spanish:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f yards", dist * 1760.0);
	      else
		sprintf (s2, "%.0f millas", dist);
	      break;
	    case german:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f yard", dist * 1760.0);
	      else
		sprintf (s2, "%.0f Meilen", dist);
	    }
	}
      else
	{
	  switch (voicelang)
	    {
	    case english:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f meters", dist * 1000.0);
	      else
		sprintf (s2, "%.0f kilometers", dist);
	      break;
	    case spanish:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f metros", dist * 1000.0);
	      else
		sprintf (s2, "%.0f kilometros", dist);
	      break;
	    case german:
	      if (dist <= 1.2)
		sprintf (s2, "%.0f meter", dist * 1000.0);
	      else if ((int) dist == 1)
		sprintf (s2, "ein kilometer");
	      else
		sprintf (s2, "%d kilometer", (int) dist);
	    }
	}

      switch (voicelang)
	{
	case english:
	  sprintf (buf, "(SayText \"Distance to destination is %s\")\n", s2);
	  break;
	case spanish:
	  sprintf (buf, "(SayText \"La distancia a la destinatin es %s\")\n",
		   s2);
	  break;
	case german:
	  sprintf (buf, "(SayText \"Die Entfernung zum Ziel ist %s\")\n", s2);
	}
      speech_out_speek (buf);
    }

  return TRUE;
}

gint
get_position_data_cb (GtkWidget *widget, guint *datum)
{
  gint e, j, i, found, foundGSV;
  gdouble secs, tx, ty;
  gchar tok[200];
  typedef struct
  {
    gchar *a1;
    gchar *a2;
    gchar *a3;
  }
  argument;
  argument *argumente;

  if (importactive)
    return TRUE;

  if (haveGARMIN)
    {
      argumente = g_new (argument, 1);
      argumente->a1 = "-p";
      argumente->a2 = "-p";
      argumente->a3 = 0;

      e = garblemain (1, (char **) argumente);
      if (e == -2)
	{
	  havepos = FALSE;
	  display_status (_("No GPS Fix found!"));
	  haveposcount = 0;
	  return TRUE;
	}
      {
	havepos = TRUE;
	haveposcount++;
      }
      current_long = glang;
      current_lat = gbreit;

      secs = g_timer_elapsed (timer, 0);

      if (secs >= 1.0)
	{
	  tx =
	    (2 * R * M_PI / 360) * cos (M_PI * current_lat / 180.0) *
	    (current_long - old_long);
	  ty = (2 * R * M_PI / 360) * (current_lat - old_lat);
#define MINMOVE 4.0
	  if (((fabs (tx)) > MINMOVE) || (((fabs (ty)) > MINMOVE)))
	    {
	      g_timer_stop (timer);
	      g_timer_start (timer);

	      if (ty == 0)
		direction = 0.0;
	      else
		direction = atan (tx / ty);

	      if (ty < 0)
		direction = M_PI + direction;
	      if (direction >= (2 * M_PI))
		direction -= 2 * M_PI;
	      if (direction < 0)
		direction += 2 * M_PI;

	      groundspeed = milesconv * sqrt (tx * tx + ty * ty) * 3.6 / secs;
	      old_lat = current_lat;
	      old_long = current_long;
	    }
	  else if (secs > 4.0)
	    groundspeed = 0.0;

	  if (groundspeed > 2000)
	    groundspeed = 0;
	  if (groundspeed < 3.6)
	    groundspeed = 0;

	  if (debug)
	    g_print ("\nTime: %f", secs);
	}
/*  display status line */
      if (posmode)
	display_status (_("Press middle mouse button for navigation"));
      else
	display_status (_("GARMIN Mode"));

      g_free (argumente);
/*  return if in GARMIN mode */
      return TRUE;
    }

/*    only if we have neither NMEA nor GARMIN, means no measured position */
  if (!haveNMEA)
    {
/*  display status line */
      if (!simmode)
	display_status (_("No GPS used"));
      else if (maploaded && !posmode)
	display_status (_("Simulation mode"));
      else if (posmode)
	display_status (_("Press middle mouse button for sim mode"));

      return TRUE;
    }

/*  this is the NMEA reading part. data comes from port 2222 served by gpsd */
  FD_ZERO (&readmask);
  FD_SET (sock, &readmask);
  timeout.tv_sec = 0;
  timeout.tv_usec = 100000;
  if (select (FD_SETSIZE, &readmask, NULL, NULL, &timeout) < 0)
    {
      perror ("select() call");
    }
  if (FD_ISSET (sock, &readmask))
    {
      if ((e = read (sock, buffer, 2000)) < 0)
	perror ("read from gpsd connection");
      buffer[e] = 0;
      if ((bigp + e) < MAXBIG)
	{
	  if (debug)
	    g_print ("\n!!bigp:%d, e: %d!!", bigp, e);
	  strcat (big, buffer);
	  if (debug)
	    g_print (", strlen big:%d", strlen (big));
	  bigp += e;
	  bigpGSV = bigp;
	  for (i = bigp; i > lastp; i--)
	    {
	      if (big[i] == '$')
		{
/*  collect string for position data $GPRMC */
		  if ((big[i + 1] == 'G') && (big[i + 2] == 'P')
		      && (big[i + 3] == 'R') && (big[i + 4] == 'M')
		      && (big[i + 5] == 'C'))
		    {
		      found = 0;
		      if (debug)
			g_print ("#RMC#");
		      for (j = i; j <= bigp; j++)
			if (big[j] == 13)
			  {
			    found = j;
			    break;
			  }
		      if (found != 0)
			{
			  strncpy (tok, (big + i), found - i);
			  tok[found - i] = 0;
			  lastp = found;
			  timeoutcount = 0;
/*  we have the $GPRMC string completed, now parse it */
			  convertRMC (tok);
/*  display the position and map in the statusline */
			  if (havepos)
			    {
			      if (posmode)
				display_status (_
						("Press middle mouse button for navigation"));
			      else
				display_status (nmeamodeandport);
			    }
			  else
			    display_status (_("No GPS Fix found!"));
			  if (debug)
			    g_print ("\n********\n%s\n*********\n", tok);
			}
		    }

		}
	    }
	}
      else
	{
	  lastp = 0;
	  bigp = e;
	  strcpy (big, buffer);
	}

/*  collect string for satellite data $GPGSV */

      for (i = bigp; i > lastp; i--)
	{
	  if (big[i] == '$')
	    {

	      if ((big[i + 1] == 'G') && (big[i + 2] == 'P')
		  && (big[i + 3] == 'G') && (big[i + 4] == 'S')
		  && (big[i + 5] == 'V'))
		{
		  foundGSV = 0;
		  if (debug)
		    g_print ("#GSV#");
		  for (j = i; j <= bigpGSV; j++)
		    if (big[j] == 13)
		      {
			foundGSV = j;
			break;
		      }
		  if (foundGSV != 0)
		    {
		      strncpy (tok, (big + i), foundGSV - i);
		      tok[foundGSV - i] = 0;
		      lastpGSV = foundGSV;

		      convertGSV (tok);
		      if (debug)
			g_print ("\n********\n%s\n*********\n", tok);
		    }
		}
	    }
	}


      if (debug)
	g_print ("\nsize:%d lastp: %d \n%s", e, lastp, buffer);
    }
  else
    {
      timeoutcount++;
      if (debug)
	g_print ("*** %d. timeout! ", timeoutcount);
      if ((timeoutcount * 80) > TIMER)
	{
	  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
	  gtk_statusbar_push (GTK_STATUSBAR (status), statusid,
			      _("No connection to GPS-Receiver!"));
	  havepos = FALSE;
	  haveposcount = 0;
	  memset (satlist, 0, sizeof (satlist));
	  memset (satlistdisp, 0, sizeof (satlist));


	}

    }


  return (TRUE);
}

/*  test if we need to load another map */
void
testnewmap ()
{
  glong best = 1000000000;
  gdouble posx, posy;
  glong bestmap = 9999999;
  gdouble pixelfactloc, bestscale = 1000000000, fact;
  gint i, skip;
  gdouble dif;

  if (importactive)
    return;


  if (posmode)
    {
      current_long = posmode_x;
      current_lat = posmode_y;
    }
  for (i = 0; i < nrmaps; i++)
    {
      skip = TRUE;
      if (displaymap_map)
	if (!(strncmp ((maps + i)->filename, "map_", 4)))
	  skip = FALSE;
      if (displaymap_top)
	if (!(strncmp ((maps + i)->filename, "top_", 4)))
	  skip = FALSE;

      if (skip)
	continue;

/*        calcxy (&posx, &posy, (maps + i)->longitude, (maps + i)->lat,1); */
/*  Longitude */
      posx =
	(Ra[(int) (100 + (maps + i)->lat)] * M_PI / 180) * cos (M_PI *
								(maps +
								 i)->lat /
								180.0) *
	(current_long - (maps + i)->longitude);
/*  latitude */
      posy =
	(Ra[(int) (100 + (maps + i)->lat)] * M_PI / 180) * (current_lat -
							    (maps + i)->lat);
      dif =
	Ra[(int) (100 + (maps + i)->lat)] * (1 -
					     (cos
					      ((M_PI *
						(current_long -
						 (maps +
						  i)->longitude)) / 180.0)));
      posy = posy + dif / 2.0;

      pixelfactloc = (maps + i)->scale / PIXELFACT;
      posx = posx / pixelfactloc;
      posy = posy / pixelfactloc;

      if ((posx > -(640 - BORDERLIMIT)) && (posx < (640 - BORDERLIMIT)))
	{
	  if (((posy - BORDERLIMIT) > -512) && ((posy + BORDERLIMIT) < 512))
	    {
	      if (scaleprefered)
		{
		  if (scalewanted > (maps + i)->scale)
		    fact = (gdouble) scalewanted / (maps + i)->scale;
		  else
		    fact = (maps + i)->scale / (gdouble) scalewanted;
		  if (fact < bestscale)
		    {
		      bestscale = fact;
		      bestmap = i;
		    }
		}
	      else
		{
		  if ((maps + i)->scale < best)
		    {
		      bestmap = i;
		      best = (maps + i)->scale;
		    }
		}
	    }			/*  End of if posy> ... */
	}

    }
  if (bestmap != 9999999)
    {
      strcpy (mapfilename, (maps + bestmap)->filename);
      if ((strcmp (oldfilename, mapfilename)) != 0)
	{
	  strcpy (oldfilename, mapfilename);
	  if (debug)
	    g_print ("\nNew map: %s\n", mapfilename);
	  pixelfact = (maps + bestmap)->scale / PIXELFACT;
	  zero_long = (maps + bestmap)->longitude;
	  zero_lat = (maps + bestmap)->lat;
	  mapscale = (maps + bestmap)->scale;
	  xoff = yoff = 0;
	  loadmap (mapfilename);
	}
    }
  else
    {
      maploaded = FALSE;
      iszoomed = FALSE;
      strcpy (mapfilename, "--------");
      strcpy (oldfilename, mapfilename);
    }
}

gint
testconfig_cb (GtkWidget *widget, guint *datum)
{
  gint i;
  if (!havedefaultpos && !messageshown)
    {
      GString *error;
      error = g_string_new (NULL);
      g_string_sprintf (error, "\n%s\n",
			_("Please create an entry:\n\nDEFAULT xxx yyy\n\n"
			  "in your ~/.gpsdrive/way.txt file,\n where xxx "
			  "is the latitude \nand yyy "
			  "is the longitude\n of your startpoint. Be sure "
			  "to have a map\n for these coordinates!"));
      error_popup ((gpointer *) error->str);
      g_string_free (error, TRUE);
      messageshown = TRUE;
      return TRUE;
    }

  for (i = 0; i < nrmaps; i++)
    {
      if ((strncmp ((maps + i)->filename, "map_", 4)))
	if ((strncmp ((maps + i)->filename, "top_", 4)))
	  {
	    GString *error;
	    error = g_string_new (NULL);
	    g_string_sprintf (error, "\n%s%d\n%s", _("Error in line "), i + 1,
			      _("I found a filename in your\n"
				" ~/.gpsdrive/map_koord.txt file,\n"
				"which are not map_* or top_* files!\n"
				"Please rename them and change the entries\n "
				"in map_koord.txt, otherwise this maps would\n"
				"not be displayed!"
				"\n\nUse map_* for street maps and\n"
				"top_* for topogrphical maps."));
	    error_popup ((gpointer *) error->str);
	    g_string_free (error, TRUE);
	    messageshown = TRUE;
	    return FALSE;
	  }
    }

  if ((wrongwplist != 0) && !messageshown)
    {
      GString *error;
      error = g_string_new (NULL);
      g_string_sprintf (error,
			_
			("Wrong format in line %d\n"
			 "in your ~/.gpsdrive/way.txt file,\n"
			 "Format must be:\n"
			 "LABEL xxx.xxx yyy.yyy\n"
			 "where xxx.xxx is the is the latitude \n"
			 "and yyy.yyy "
			 "is the longitude\n of your waypoints.\n"
			 "Be sure "
			 "to have a dot\n"
			 " for the decimal point!"
			 "\n\nNo waypoints loaded!"), wrongwplist);
      error_popup ((gpointer *) error->str);
      g_string_free (error, TRUE);
      messageshown = TRUE;
    }
  if (havefriends)
    friendsagent_cb (NULL, 0);
  return FALSE;
}

gint
watchwp_cb (GtkWidget *widget, guint *datum)
{
  gint angel, i, radarnear;
  gdouble d;
  gchar buf[400], lname[200], l2name[200];
  gdouble ldist = 9999.0, l2dist = 9999.0;
  gdouble tx, ty;

/*  calculate new earth radius */
  earthr = calcR (current_lat);

  if (importactive)
    return TRUE;

  foundradar = FALSE;
  radarnear = FALSE;
  for (i = 0; i < maxwp; i++)
    {
      if ((strstr ((wayp + i)->name, "R-")) == (char *) (&(wayp + i)->name))
	{
	  d = calcdist2 ((wayp + i)->longitude, (wayp + i)->lat);
	  if (d < 0.6)
	    {
	      tx = -current_long + (wayp + i)->longitude;
	      ty = -current_lat + (wayp + i)->lat;
	      radarbearing = atan (tx / ty);
	      if (ty < 0)
		radarbearing = M_PI + radarbearing;
	      radarbearing -= direction;
	      if (radarbearing >= (2 * M_PI))
		radarbearing -= 2 * M_PI;
	      if (radarbearing < 0)
		radarbearing += 2 * M_PI;
	      if (radarbearing < 0)
		radarbearing += 2 * M_PI;
	      angel = radarbearing * 180.0 / M_PI;

	      if ((angel < 40) || (angel > 320))
		{
		  foundradar = TRUE;
		  if (d < ldist)
		    {
		      ldist = d;
		      strcpy (lname, (wayp + i)->name);
		    }
		  if (d < 0.2)
		    {
		      foundradar = TRUE;
		      radarnear = TRUE;
		      if (d < l2dist)
			{
			  l2dist = d;
			  strcpy (l2name, (wayp + i)->name);
			}
		    }
		}

	    }

	}
    }
  if (!foundradar)
    {
      strcpy (lastradar, "----");
      strcpy (lastradar2, "----");
    }
  else
    {
      if ((strcmp (lname, lastradar)) != 0)
	{
	  strcpy (lastradar, lname);
	  switch (voicelang)
	    {
	    case english:
	      sprintf (buf,
		       "(SayText \"Danger, Danger, Radar in %d meters, Your speed is %d\")\n",
		       (int) (ldist * 1000.0), (int) groundspeed);
	      break;
	    case spanish:
	      sprintf (buf,
		       "(SayText \"Atencin Atencin, control de  velocidad en %d metros, Su velocidad es %d\")\n",
		       (int) (ldist * 1000.0), (int) groundspeed);
	      break;
	    case german:
	      sprintf (buf,
		       "(SayText \"Achtung, Achtung, Radar in %d metern, Ihre Geschwindigkeit ist %d\")\n",
		       (int) (ldist * 1000.0), (int) groundspeed);
	    }
	  speech_out_speek (buf);
	}

      if (radarnear)
	if ((strcmp (l2name, lastradar2)) != 0)
	  {
	    strcpy (lastradar2, l2name);
	    switch (voicelang)
	      {
	      case english:
		sprintf (buf,
			 "(SayText \"Information, Radar in %d meters\")\n",
			 (int) (ldist * 1000.0));
		break;
	      case spanish:
		sprintf (buf,
			 "(SayText \"Informacin, control de  velocidad en %d metros\")\n",
			 (int) (ldist * 1000.0));
		break;
	      case german:
		sprintf (buf,
			 "(SayText \"Information, Radar in %d meter\")\n",
			 (int) (ldist * 1000.0));
	      }
	    speech_out_speek (buf);
	  }

    }

  return TRUE;
}

/*  display upper status line */
void
display_status2 ()
{
  gchar s2[100], buf[200];
  gint h, m;
  gdouble secs, v;
  if (downloadactive == TRUE)
    return;
  if (importactive == TRUE)
    return;
  secs = g_timer_elapsed (disttimer, 0);
  h = hours;
  m = minutes;
  if (secs >= 300.0)
    {
      g_timer_stop (disttimer);
      g_timer_start (disttimer);
      v = 3600.0 * (olddist - dist) / secs;
      h = dist / v;
      m = 60 * (dist / v - h);
      if (debug)
	g_print ("\nsecs: %.0fs,v:%.0f,h:%d,m:%d", secs, v, h, m);
      if ((m < 0) || (h > 99))
	{
	  h = 99;
	  m = 99;
	}
      olddist = dist;
      hours = h;
      minutes = m;
      if (!muteflag)
	if (hours < 99)
	  {
	    switch (voicelang)
	      {
	      case english:
		if (hours > 0)
		  sprintf (buf,
			   "(SayText \"Arrival in approximatly %d hours and %d minutes\")\n",
			   hours, minutes);
		else
		  sprintf (buf,
			   "(SayText \"Arrival in approximatly %d minutes\")\n",
			   minutes);
		break;
	      case spanish:
		if (hours > 0)
		  sprintf (buf,
			   "(SayText \"Llegada en %d horas y %d minutos\")\n",
			   hours, minutes);
		else
		  sprintf (buf,
			   "(SayText \"Llegada en %d minutos\")\n", minutes);
		break;
	      case german:
		if (hours > 0)
		  {
		    if (hours == 1)
		      sprintf (buf,
			       "(SayText \"Ankunft in circa einer Stunde und %d minuten\")\n",
			       minutes);
		    else
		      sprintf (buf,
			       "(SayText \"Ankunft in circa %d Stunden und %d minuten\")\n",
			       hours, minutes);
		  }
		else
		  sprintf (buf,
			   "(SayText \"Ankunft in zirca %d minuten\")\n",
			   minutes);
		speech_out_speek (buf);
	      }
	  }

    }


  sprintf (s2, "%8.5f", current_lat);
  gtk_label_set_text (GTK_LABEL (l1), s2);
  sprintf (s2, "%8.5f", current_long);
  gtk_label_set_text (GTK_LABEL (l2), s2);
  gtk_label_set_text (GTK_LABEL (l3), mapfilename);
  sprintf (s2, "1:%ld", mapscale);
  gtk_label_set_text (GTK_LABEL (l4), s2);
  sprintf (s2, "%3.0f", direction * 180.0 / M_PI);
  gtk_label_set_text (GTK_LABEL (l5), s2);
  sprintf (s2, "%3.0f", bearing * 180.0 / M_PI);
  gtk_label_set_text (GTK_LABEL (l6), s2);
  sprintf (s2, "%2d:%02dh", h, m);
  gtk_label_set_text (GTK_LABEL (l7), s2);
  if (scaleprefered)
    sprintf (s2, "1:%d", scalewanted);
  else
    sprintf (s2, _("Auto"));
  gtk_label_set_text (GTK_LABEL (l8), s2);
}

/* draw the marker on the map */
gint
drawmarker_cb (GtkWidget *widget, guint *datum)
{

  if (importactive)
    return TRUE;


/*  we test if we have to load a new map because we are outside 
the currently loaded map */
  testnewmap ();

/* The position calculation is made in expose_cb() */
  gtk_widget_draw (drawing_area, NULL);	/* this  calls expose handler */

  return TRUE;
}

/* Friends agent */
gint
friendsagent_cb (GtkWidget *widget, guint *datum)
{

/*  send position to friendsserver */
  if (havefriends)
    {
      time_t t;
      struct tm *ts;
      gchar buf3[40], buf[200], la[20], lo[20];

      time (&t);
      ts = gmtime (&t);
      strftime (buf3, sizeof (buf3), "%H:%M(%a)", ts);
      sprintf (la, "%10.6f", current_lat);
      sprintf (lo, "%10.6f", current_long);
      g_strdelimit (la, ",", '.');
      g_strdelimit (lo, ",", '.');

      sprintf (buf, "POS: %s %s %s %s %.0f %.0f\n",
	       friendsname, la, lo, buf3, groundspeed / milesconv,
	       180.0 * direction / M_PI);
      write (friendssock, buf, strlen (buf));
    }

  return TRUE;
}

/* Master agent */
gint
masteragent_cb (GtkWidget *widget, guint *datum)
{
  if (tracknr > (tracklimit - 1000))
    {
      track = g_renew (trackstruct, track, tracklimit + 100000);
      tracklimit += 100000;
    }
  if (trackcoordnr > (trackcoordlimit - 1000))
    {
      trackcoord =
	g_renew (trackcoordstruct, trackcoord, trackcoordlimit + 100000);
      trackcoordlimit += 100000;
    }
  return TRUE;
}

/* draw track on image */
gint
storetrack_cb (GtkWidget *widget, guint *datum)
{
  gint i;
  gchar buf3[35];
  time_t t;
  struct tm *ts;

/*    if (posmode) */
/*      return TRUE; */
  if (posmode)
    i = 1;
  else
    i = 2;

/*    g_print ("\nHavepos: %d", havepos); */
  if ((!simmode && !havepos) || posmode /*  ||((!simmode &&haveposcount<3)) */ )	/* we have no valid position */
    {
      (trackcoord + trackcoordnr)->longi = 1001.0;
      (trackcoord + trackcoordnr)->lat = 1001.0;
    }
  else
    {
      (trackcoord + trackcoordnr)->longi = current_long;
      (trackcoord + trackcoordnr)->lat = current_lat;
    }


/*  The double storage seems to be silly, but I have to use  */
/*  gdk_draw_segments instead of gdk_draw_lines.   */
/*  gkd_draw_lines is dog slow because of a gdk-bug. */

  if ((tracknr & 1) == 0)
    {
      if ((trackcoord + trackcoordnr)->longi < 1000.0)
	{
	  (track + tracknr)->x = posx;
	  (track + tracknr)->y = posy;
	  tracknr++;
	}
    }
  else
    {
      if ((trackcoord + trackcoordnr)->longi < 1000.0)
	{
	  if ((posx != (track + tracknr - 1)->x)
	      || (posy != (track + tracknr - 1)->y))
	    {
	      (track + tracknr)->x = (track + tracknr + 1)->x = posx;
	      (track + tracknr)->y = (track + tracknr + 1)->y = posy;
	      tracknr += 2;
	    }
	}
      else
	tracknr = tracknr & ((glong) - 2);
    }
  time (&t);
  ts = localtime (&t);
  strncpy (buf3, asctime (ts), 32);
  buf3[strlen (buf3) - 1] = '\0';	/* get rid of \n */
  strcpy ((trackcoord + trackcoordnr)->postime, buf3);
  trackcoordnr++;

  return TRUE;
}


/*  if zoom, xoff, yoff or map are changed */
void
rebuildtracklist (void)
{
  gdouble posxdest, posydest;
  gint i;

  if (!maploaded)
    return;

  if (!trackflag)
    return;
  if (importactive)
    return;

  tracknr = 0;
  for (i = 0; i < trackcoordnr; i++)
    {
      calcxy (&posxdest, &posydest, (trackcoord + i)->longi,
	      (trackcoord + i)->lat, zoom);

      if ((tracknr & 1) == 0)
	{
	  if ((trackcoord + i)->longi < 1000.0)
	    {
	      (track + tracknr)->x = posxdest;
	      (track + tracknr)->y = posydest;
	      tracknr++;
	    }
	}
      else
	{
	  if ((trackcoord + i)->longi < 1000.0)
	    {
	      if ((posxdest > -50) && (posxdest < (SCREEN_X + 50))
		  && (posydest > -50) && (posydest < (SCREEN_Y + 50)))
		{
		  if ((posxdest != (track + tracknr - 1)->x)
		      || (posydest != (track + tracknr - 1)->y))
		    {
		      (track + tracknr)->x = (track + tracknr + 1)->x =
			posxdest;
		      (track + tracknr)->y = (track + tracknr + 1)->y =
			posydest;
		      tracknr += 2;
		    }
		}
	    }
	  else
	    tracknr = tracknr & ((glong) - 2);
	}

    }

}

void
drawfriends (void)
{
  gint e, i, k;
  gdouble posxdest, posydest, clong, clat, direction;
  gchar buffer[2010], dtype[20], *data, **nstr;


  FD_ZERO (&friendsreadmask);
  FD_SET (friendssock, &friendsreadmask);
  friendstimeout.tv_sec = 0;
  friendstimeout.tv_usec = 10000;
  if (select (FD_SETSIZE, &friendsreadmask, NULL, NULL, &friendstimeout) < 0)
    {
      perror ("select() call");
    }
  if (FD_ISSET (friendssock, &friendsreadmask))
    {
      if ((e = read (friendssock, buffer, 2000)) < 0)
	perror ("read from friendsd connection");
      buffer[e] = 0;
      strcat (friendsbuffer, buffer);
      friendsbuffstart = strstr (friendsbuffer, "$START:$");
      friendsbuffend = strstr (friendsbuffer, "$END:$");
      if ((friendsbuffstart != NULL) && (friendsbuffend != NULL))
	{
	  /*  we found a complete data block */
	  *friendsbuffend = 0;
	  data = friendsbuffstart + 9;
/*  	  if (debug) */
	  g_print ("\nData block is:\n%s\n", data);
	  nstr = g_strsplit (data, "\n", 0);
	  i = 0;
	  while (nstr[i] != NULL)
	    {
	      strcpy (friendsspeed[i], "");
	      if ((strstr (buffer, "POS:")) != NULL)
		e = sscanf (nstr[i], "%s %s %s %s %s %s %s",
			    dtype, friendstxt[i], friendslat[i],
			    friendslon[i], friendstim[i], friendsspeed[i],
			    friendsdir[i]);
	      strcat (friendsspeed[i], "km/h");
	      i++;
	    }
	  friendsbuffer[0] = 0;
	  g_strfreev (nstr);
	  maxfriends = i;
	}
    }


  for (i = 0; i < maxfriends; i++)
    {
      clong = g_strtod (friendslon[i], NULL);
      clat = g_strtod (friendslat[i], NULL);

      calcxy (&posxdest, &posydest, clong, clat, zoom);

      if ((posxdest >= 0) && (posxdest < SCREEN_X))
	{

	  if ((posydest >= 0) && (posydest < SCREEN_Y))
	    {

	      gdk_pixbuf_render_to_drawable_alpha (friendspixbuf, drawable,
						   /*  kontext, */ 0, 0,
						   posxdest - 18,
						   posydest - 18, 37, 37,
						   GDK_PIXBUF_ALPHA_BILEVEL,
						   127, GDK_RGB_DITHER_NORMAL,
						   0, 0);
	      gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);
/*  draw pointer to direction */
	      gdk_gc_set_foreground (kontext, &yellow);
	      direction = strtod (friendsdir[i], NULL) * M_PI / 180.0;
	      gdk_draw_line (drawable, kontext,
			     posxdest + 4 * sin (direction),
			     posydest - 4 * cos (direction),
			     posxdest + 20 * sin (direction),
			     posydest - 20 * cos (direction));
	      gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);
	      gdk_draw_arc (drawable, kontext, 0, posxdest + 2 - 7,
			    posydest + 2 - 7, 10, 10, 0, 360 * 64);

/*  draw + sign at destination */
/*  	      gdk_gc_set_foreground (kontext, &red); */
/*  	      gdk_draw_line (drawable, kontext, posxdest + 1, */
/*  			     posydest + 1 - 5, posxdest + 1, */
/*  			     posydest + 1 + 5); */
/*  	      gdk_draw_line (drawable, kontext, posxdest + 1 + 5, */
/*  			     posydest + 1, posxdest + 1 - 5, posydest + 1); */

/*  Draw name */
	      k =
		gdk_text_width (smalltextfont, friendstxt[i],
				strlen (friendstxt[i]));
	      gdk_gc_set_foreground (kontext, &white);
	      gdk_draw_rectangle (drawable, kontext, 1, posxdest + 18,
				  posydest - 6, k + 1, 14);
	      gdk_gc_set_foreground (kontext, &blue);
	      gdk_draw_text (drawable, smalltextfont, kontext,
			     posxdest + 18, posydest + 6,
			     friendstxt[i], strlen (friendstxt[i]));
/*  Draw time */
	      k =
		gdk_text_width (smalltextfont, friendstim[i],
				strlen (friendstim[i]));
	      gdk_gc_set_foreground (kontext, &white);
	      gdk_draw_rectangle (drawable, kontext, 1, posxdest + 18,
				  posydest + 8, k + 1, 14);
	      gdk_gc_set_foreground (kontext, &blue);
	      gdk_draw_text (drawable, smalltextfont, kontext,
			     posxdest + 18, posydest + 20,
			     friendstim[i], strlen (friendstim[i]));
/*  Draw speed */
	      k =
		gdk_text_width (smalltextfont, friendsspeed[i],
				strlen (friendsspeed[i]));
	      gdk_gc_set_foreground (kontext, &white);
	      gdk_draw_rectangle (drawable, kontext, 1, posxdest + 18,
				  posydest + 22, k + 1, 14);
	      gdk_gc_set_foreground (kontext, &blue);
	      gdk_draw_text (drawable, smalltextfont, kontext,
			     posxdest + 18, posydest + 34,
			     friendsspeed[i], strlen (friendsspeed[i]));

	    }
	}
    }



}

/* draw track on image */
void
drawtracks (void)
{
  gint t;

/*    if (!maploaded) */
/*      return; */
  if (!trackflag)
    return;
  if (importactive)
    return;
  t = tracknr >> 1;
  if (t < 1)
    return;


  gdk_gc_set_foreground (kontext, &green);
  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);

  gdk_draw_segments (drawable, kontext, (GdkSegment *) track, t);

  return;

}

/* draw the marker on the map */
gint
drawmarker (GtkWidget *widget, guint *datum)
{
  gint16 poly[16], j, k, yabs, i, h, shownwp = 0;
  gdouble posxdest, posydest;
  gdouble w, kurz;
  gchar s2[100], txt[200];
  gblink = !gblink;

  if (importactive)
    return TRUE;
  drawtracks ();

  if (wpflag)
    {
/*  draw waypoints */
      gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);
      for (i = 0; i < maxwp; i++)
	{
	  calcxy (&posxdest, &posydest, (wayp + i)->longitude,
		  (wayp + i)->lat, zoom);

	  if ((posxdest >= 0) && (posxdest < SCREEN_X)
	      && (shownwp < MAXSHOWNWP))
	    {

	      if ((posydest >= 0) && (posydest < SCREEN_Y))
		{
		  shownwp++;
		  strcpy (txt, (wayp + i)->name);
/*  draw + sign at destination */
		  gdk_gc_set_foreground (kontext, &red);
		  gdk_draw_line (drawable, kontext, posxdest + 1,
				 posydest + 1 - 5, posxdest + 1,
				 posydest + 1 + 5);
		  gdk_draw_line (drawable, kontext, posxdest + 1 + 5,
				 posydest + 1, posxdest + 1 - 5,
				 posydest + 1);
		  k = gdk_text_width (smalltextfont, txt, strlen (txt));
		  gdk_gc_set_foreground (kontext, &white);
		  gdk_draw_rectangle (drawable, kontext, 1, posxdest + 10,
				      posydest - 6, k + 1, 14);
		  gdk_gc_set_foreground (kontext, &red);
		  gdk_draw_text (drawable, smalltextfont, kontext,
				 posxdest + 10, posydest + 6, txt,
				 strlen (txt));
		}
	    }
	}
    }

  if (havefriends)
    drawfriends ();

/*  draw scale */
  {
    gint pixels;
    gint m, l;
    gchar txt[100];
    pixels = 141 / milesconv;
    gdk_gc_set_foreground (kontext, &black);
    m = mapscale / (20 * zoom);
    if (m < 1000)
      {
	sprintf (txt, "%d%s", m, (milesflag) ? "yrds" : "m");
	if (milesflag)
	  pixels = pixels * milesconv * 0.9144;
      }
    else
      sprintf (txt, "%.1f%s", m / 1000.0, (milesflag) ? "mi" : "km");
    l =
      (SCREEN_X - 20) - pixels + (pixels -
				  gdk_text_width (textfont, txt,
						  strlen (txt))) / 2;
    gdk_draw_text (drawable, textfont, kontext, l,
		   SCREEN_Y - 20, txt, strlen (txt));
    if (debug)
      g_print ("%d\n", m);
    gdk_gc_set_line_attributes (kontext, 3, 0, 0, 0);
    gdk_draw_line (drawable, kontext, (SCREEN_X - 20) - pixels,
		   SCREEN_Y - 20 + 5, (SCREEN_X - 20), SCREEN_Y - 20 + 5);
    gdk_draw_line (drawable, kontext, (SCREEN_X - 20) - pixels,
		   SCREEN_Y - 20, (SCREEN_X - 20) - pixels,
		   SCREEN_Y - 20 + 11);
    gdk_draw_line (drawable, kontext, (SCREEN_X - 20),
		   SCREEN_Y - 20, (SCREEN_X - 20), SCREEN_Y - 20 + 11);

    if (savetrack)
      {
	k = gdk_text_width (smalltextfont, savetrackfn, strlen (savetrackfn));
	gdk_gc_set_foreground (kontext, &white);
	gdk_draw_rectangle (drawable, kontext, 1, 10,
			    SCREEN_Y - 21, k + 3, 14);
	gdk_gc_set_foreground (kontext, &red);
	gdk_draw_text (drawable, smalltextfont, kontext,
		       11, SCREEN_Y - 10, savetrackfn, strlen (savetrackfn));

/*      gdk_draw_text (drawable, textfont, kontext, 10, */
/*  		   SCREEN_Y - 10, savetrackfn, strlen (savetrackfn)); */
      }
  }

  if (posmode)
    {
      blink = TRUE;
    }
  if (havepos || blink)
    {
      if (posmode)
	{
	  gdk_gc_set_foreground (kontext, &blue);
	  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);
	  gdk_draw_rectangle (drawable, kontext, 0, posx - 10,
			      posy - 10, 20, 20);
	}
      else
	{
	  gdk_gc_set_foreground (kontext, &black);
	  gdk_gc_set_line_attributes (kontext, 3, 0, 0, 0);
	  gdk_draw_arc (drawable, kontext, 0, posx - 7, posy - 7, 14,
			14, 0, 360 * 64);
/*  draw pointer to destination */
	  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);
	  gdk_draw_line (drawable, kontext,
			 posx + 4 * sin (angel_to_destination),
			 posy - 4 * cos (angel_to_destination),
			 posx + 20 * sin (angel_to_destination),
			 posy - 20 * cos (angel_to_destination));
	  gdk_gc_set_foreground (kontext, &red);
/*  draw pointer to direction */
	  gdk_draw_line (drawable, kontext, posx + 4 * sin (direction),
			 posy - 4 * cos (direction),
			 posx + 20 * sin (direction),
			 posy - 20 * cos (direction));
	  gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);
	  gdk_draw_arc (drawable, kontext, 0, posx + 2 - 7,
			posy + 2 - 7, 10, 10, 0, 360 * 64);
	}
/*  If we are in position mode we set direction to zero to see where is the  */
/*  target  */
      if (posmode)
	direction = 0;

      bearing = angel_to_destination - direction;
      if (bearing < 0)
	bearing += 2 * M_PI;
      if (bearing > (2 * M_PI))
	bearing -= 2 * M_PI;
      display_status2 ();
/*  draw bearing arrow */
      gdk_gc_set_foreground (kontext, &mygray);
      gdk_draw_rectangle (drawable2, kontext, 1, 0, 0, PSIZE, PSIZE);
      gdk_gc_set_foreground (kontext, &black);
      gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
      w = bearing + M_PI;
#define KURZW 1.2
      kurz = cos (KURZW);
      poly[0] = PSIZE / 2 + PSIZE / 2.5 * cos (w);	/* x */
      poly[1] = PSIZE / 2 + PSIZE / 2.5 * sin (w);	/* y */
      poly[2] = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI_2);
      poly[3] = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI_2);
      poly[4] = PSIZE / 2 + PSIZE / 2.5 * cos (w + M_PI);
      poly[5] = PSIZE / 2 + PSIZE / 2.5 * sin (w + M_PI);
      poly[6] = PSIZE / 2 + PSIZE / 2 * kurz * cos (w + M_PI);
      poly[7] = PSIZE / 2 + PSIZE / 2 * kurz * sin (w + M_PI);
      poly[8] = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI + KURZW);
      poly[9] = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI + KURZW);
      poly[10] = PSIZE / 2 + PSIZE / 2 * cos (w + 2 * M_PI - KURZW);
      poly[11] = PSIZE / 2 + PSIZE / 2 * sin (w + 2 * M_PI - KURZW);
      poly[12] = PSIZE / 2 + PSIZE / 2 * kurz * cos (w);
      poly[13] = PSIZE / 2 + PSIZE / 2 * kurz * sin (w);
      poly[14] = poly[0];
      poly[15] = poly[1];
      gdk_draw_polygon (drawable2, kontext, 1, (GdkPoint *) poly, 8);

      if (foundradar)
	{
	  gdk_gc_set_foreground (kontext, &red);
	  gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
	  w = radarbearing + M_PI;
	  if (w < 0)
	    w += 2 * M_PI;
	  if (w > (2 * M_PI))
	    w -= 2 * M_PI;
/*  	  g_print ("\nRadarbearing: %g w: %g", radarbearing, w); */
#define KURZW 1.2
	  kurz = cos (KURZW);
	  poly[0] = PSIZE / 2 + PSIZE / 2.5 * cos (w);	/* x */
	  poly[1] = PSIZE / 2 + PSIZE / 2.5 * sin (w);	/* y */
	  poly[2] = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI_2);
	  poly[3] = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI_2);
	  poly[4] = PSIZE / 2 + PSIZE / 2.5 * cos (w + M_PI);
	  poly[5] = PSIZE / 2 + PSIZE / 2.5 * sin (w + M_PI);
	  poly[6] = PSIZE / 2 + PSIZE / 2 * kurz * cos (w + M_PI);
	  poly[7] = PSIZE / 2 + PSIZE / 2 * kurz * sin (w + M_PI);
	  poly[8] = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI + KURZW);
	  poly[9] = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI + KURZW);
	  poly[10] = PSIZE / 2 + PSIZE / 2 * cos (w + 2 * M_PI - KURZW);
	  poly[11] = PSIZE / 2 + PSIZE / 2 * sin (w + 2 * M_PI - KURZW);
	  poly[12] = PSIZE / 2 + PSIZE / 2 * kurz * cos (w);
	  poly[13] = PSIZE / 2 + PSIZE / 2 * kurz * sin (w);
	  poly[14] = poly[0];
	  poly[15] = poly[1];
	  gdk_draw_polygon (drawable2, kontext, 1, (GdkPoint *) poly, 8);
	}
    }


/*  now draw marker for destination point */

  calcxy (&posxdest, &posydest, target_long, target_lat, zoom);

  if (crosstoogle)
    gdk_gc_set_foreground (kontext, &blue);
  else
    gdk_gc_set_foreground (kontext, &red);
  crosstoogle = !crosstoogle;
  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);
/*  draw + sign at destination */
  gdk_draw_line (drawable, kontext, posxdest + 1,
		 posydest + 1 - 10, posxdest + 1, posydest + 1 - 2);
  gdk_draw_line (drawable, kontext, posxdest + 1,
		 posydest + 1 + 2, posxdest + 1, posydest + 1 + 10);
  gdk_draw_line (drawable, kontext, posxdest + 1 + 10,
		 posydest + 1, posxdest + 1 + 2, posydest + 1);
  gdk_draw_line (drawable, kontext, posxdest + 1 - 2,
		 posydest + 1, posxdest + 1 - 10, posydest + 1);
/*  if distance is less then 1 km show meters */
  if (milesflag)
    {
      if (dist <= 1.0)
	sprintf (s2, "%4.0fyrds", dist * 1760.0);
      else
	sprintf (s2, "%8.2fmi", dist);
    }
  else
    {
      if (dist <= 1.0)
	sprintf (s2, "%4.0fm", dist * 1000.0);
      else
	sprintf (s2, "%8.2fkm", dist);
    }
/*    display distance, speed and zoom */
  gtk_label_set_text (GTK_LABEL (distlabel), s2);
  if (milesflag)
    sprintf (s2, "%5.1fmph", groundspeed);
  else
    sprintf (s2, "%5.1f%s", groundspeed, _("km/h"));
  gtk_label_set_text (GTK_LABEL (speedlabel), s2);
  sprintf (s2, "% 2dx", zoom);
  gtk_label_set_text (GTK_LABEL (zoomlabel), s2);
  if (simmode)
    blink = TRUE;
  else
    {
      if (!havepos)
	blink = !blink;
    }

/*  draw field strength only in NMEA modus*/
  if (haveNMEA)
    {
      gdk_gc_set_foreground (kontext, &white);
      gdk_draw_rectangle (drawable3, kontext, 1, 3, 0, PSIZE - 6, PSIZE - 1);
      gdk_gc_set_foreground (kontext, &darkgrey);
      gdk_gc_set_line_attributes (kontext, 5, 0, 0, 0);
      k = 0;
      for (i = 0; i < 16; i++)
	{
	  if (i > 5)
	    yabs = PSIZE;
	  else
	    yabs = PSIZE / 2;
	  h = PSIZE / 2 - 2;
	  gdk_draw_line (drawable3, kontext, 7 + 7 * k, yabs,
			 7 + 7 * k, yabs - h);
	  k++;
	  if (k > 5)
	    k = 0;
	}

      gdk_gc_set_foreground (kontext, &red);
      j = k = 0;
      for (i = 0; i < 40; i++)
	if (satlistdisp[i][0] != 0)
	  {
	    if (j > 5)
	      yabs = PSIZE;
	    else
	      yabs = PSIZE / 2 - 2;
	    h = satlistdisp[i][1] - 30;
	    if (h < 0)
	      h = 0;
	    gdk_draw_line (drawable3, kontext, 7 + 7 * k, yabs,
			   7 + 7 * k,
			   yabs - (PSIZE / 2) * h / (PSIZE / 2 - 5));
	    k++;
	    if (k > 5)
	      k = 0;
	    j++;
	  }
    }

  return (TRUE);
}

gdouble
calcdist (gdouble longi, gdouble lati)
{
  double a, a1, a2, c, d, dlon, dlat, sa, radiant = M_PI / 180;
  dlon = radiant * (current_long - longi);
  dlat = radiant * (current_lat - lati);
  a1 = sin (dlat / 2);
  a2 = sin (dlon / 2);
  a =
    (a1 * a1) + cos (lati * radiant) * cos (current_lat * radiant) * a2 * a2;
  sa = sqrt (a);
  if (sa <= 1.0)
    c = 2 * asin (sa);
  else
    c = 2 * asin (1.0);
  d = (Ra[(int) (100 + current_lat)] + Ra[(int) (100 + lati)]) * c / 2.0;
  return milesconv * d / 1000.0;
}

/*  same as calcdist, but don't recalculate earthR */
gdouble
calcdist2 (gdouble longi, gdouble lati)
{
  double a, a1, a2, c, d, dlon, dlat, sa, radiant = M_PI / 180;
  dlon = radiant * (current_long - longi);
  dlat = radiant * (current_lat - lati);
  a1 = sin (dlat / 2);
  a2 = sin (dlon / 2);
  a =
    (a1 * a1) + cos (lati * radiant) * cos (current_lat * radiant) * a2 * a2;
  sa = sqrt (a);
  if (sa <= 1.0)
    c = 2 * asin (sa);
  else
    c = 2 * asin (1.0);
  d = R * c;
  return milesconv * d / 1000.0;
}

/* Copy Image from loaded map */
gint
exposemini_cb (GtkWidget *widget, guint *datum)
{
/*  draw the minimap */
  if (!miniimage)
    return TRUE;

  gdk_pixbuf_render_to_drawable (miniimage, drawing_area4->window,
				 kontext, 0, 0, 0, 0, 128, 103,
				 GDK_RGB_DITHER_NONE, 0, 0);
  gdk_gc_set_foreground (kontext, &red);
  gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);

  gdk_draw_rectangle (drawing_area4->window, kontext, 0,
		      (64 - 32 / zoom) + xoff / (zoom * 10),
		      (50 - 25 / zoom) + yoff / (zoom * 10),
		      SCREEN_X / (zoom * 10), SCREEN_Y / (zoom * 10));

  return TRUE;
}

/* Copy Image from loaded map */
gint
expose_cb (GtkWidget *widget, guint *datum)
{
  gint x, y, i, oldxoff, oldyoff, xoffmax, yoffmax;
  gdouble tx, ty;
  gchar name[40];

  errortextmode = FALSE;

  if (!importactive)
    {
/*  We don't need to draw anything if there is no map yet */
      if (!maploaded)
	{
	  display_status (_("No map available for this position!"));
/*        return TRUE; */
	}

      if (posmode)
	{
	  current_long = posmode_x;
	  current_lat = posmode_y;
	}


/*  get pos for current position */
      calcxy (&posx, &posy, current_long, current_lat, zoom);
/*  do this because calcxy already substracted xoff and yoff */
      posx = posx + xoff;
      posy = posy + yoff;

/*  Calculate Angel to destination */
      tx =
	(2 * R * M_PI / 360) * cos (M_PI * current_lat / 180.0) *
	(target_long - current_long);
      ty = (2 * R * M_PI / 360) * (target_lat - current_lat);
      angel_to_destination = atan (tx / ty);
/*  correct the value to be < 2*PI */
      if (ty < 0)
	angel_to_destination = M_PI + angel_to_destination;
      if (angel_to_destination >= (2 * M_PI))
	angel_to_destination -= 2 * M_PI;
      if (angel_to_destination < 0)
	angel_to_destination += 2 * M_PI;
      if (debug)
	g_print ("\nAngel_To_Destination: %.0f",
		 angel_to_destination * 180 / M_PI);

      if (havefriends && targetname[0] == '*')
	for (i = 0; i < maxfriends; i++)
	  {
	    strcpy (name, "*");
	    strcat (name, friendstxt[i]);
	    if ((strcmp (targetname, name)) == 0)
	      {
		target_lat = g_strtod (friendslat[i], NULL);
		target_long = g_strtod (friendslon[i], NULL);
	      }
	  }

/*  Calculate distance to destination */
      dist = calcdist (target_long, target_lat);
/*  correct the shift of the map */
      oldxoff = xoff;
      oldyoff = yoff;
/*  now we test if the marker fits into the map and set the shift of the 
little SCREEN_XxSCREEN_Y region in relation to the real 1280x1024 map */


      x = posx - xoff;
      y = posy - yoff;
      xoffmax = SCREEN_X * zoom - SCREEN_X_2;
      yoffmax = SCREEN_Y * zoom - SCREEN_Y_2;
      if (x < BORDERLIMIT)
	xoff -= 2 * BORDERLIMIT;
      if ((xoff - SCREEN_X_2) / zoom < -SCREEN_X)
	xoff = -SCREEN_X * zoom + SCREEN_X_2;
      if (x > (SCREEN_X - BORDERLIMIT))
	xoff += 2 * BORDERLIMIT;
      if ((xoff + SCREEN_X_2) / zoom > SCREEN_X)
	xoff = SCREEN_X * zoom - SCREEN_X_2;
      if (y < BORDERLIMIT)
	yoff -= 2 * BORDERLIMIT;
      if ((yoff - SCREEN_Y_2) / zoom < -SCREEN_Y)
	yoff = -SCREEN_Y * zoom + SCREEN_Y_2;
      if (y > (SCREEN_Y - BORDERLIMIT))
	yoff += 2 * BORDERLIMIT;
      if ((yoff + SCREEN_Y_2) / zoom > SCREEN_Y)
	yoff = SCREEN_Y * zoom - SCREEN_Y_2;
/*  we only need to create a new region if the shift is not changed */
      if ((oldxoff != xoff) || (oldyoff != yoff))
	iszoomed = FALSE;
      if (debug)
	g_print ("\nx: %d  xoff: %d Zoom: %d xoffmax: %d\n", x,
		 xoff, zoom, xoffmax);
      if (debug)
	g_print ("\ny: %d  yoff: %d Zoom: %d yoffmax: %d\n", y,
		 yoff, zoom, yoffmax);
      posx = posx - xoff;
      posy = posy - yoff;

    }
  else
    {
/*        xoff = 0; */
/*        yoff = 0; */
/*        zoom = 1; */
/*        iszoomed = FALSE; */
    }

/*  zoom from to 1280x1024 map to the SCREEN_XxSCREEN_Y region */
  if (!iszoomed)
    {
      rebuildtracklist ();

      if (tempimage != NULL)
	gdk_pixbuf_unref (tempimage);
      tempimage = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 0, 8, 1280, 1024);
      if (maploaded)
	gdk_pixbuf_scale (image, tempimage, 0, 0, 1280, 1024,
			  640 - xoff - 640 * zoom,
			  512 - yoff - 512 * zoom, zoom, zoom,
			  GDK_INTERP_BILINEAR);
      if (debug)
	g_print ("\nmap zoomed!\n");
      iszoomed = TRUE;
      exposemini_cb (NULL, 0);

    }
/*  draw the image */
  gdk_pixbuf_render_to_drawable (tempimage, drawable, kontext,
				 640 - SCREEN_X_2,
				 512 - SCREEN_Y_2, 0, 0,
				 SCREEN_X, SCREEN_Y,
				 GDK_RGB_DITHER_NORMAL, 0, 0);
  drawmarker (0, 0);
  gdk_draw_pixmap (drawing_area->window, kontext, drawable, 0,
		   0, 0, 0, SCREEN_X, SCREEN_Y);
  return TRUE;
}

/*  This is called in simulation mode, it moves the position to the  */
/*  selected destination */
gint
simulated_pos (GtkWidget *widget, guint *datum)
{
  gdouble ACCELMAX, ACCEL;
  gdouble secs, tx, ty;
  ACCELMAX = 0.00002 + dist / 30000.0;
  ACCEL = ACCELMAX / 20.0;
  long_diff += ACCEL * sin (angel_to_destination);
  lat_diff += ACCEL * cos (angel_to_destination);
  if (long_diff > ACCELMAX)
    long_diff = ACCELMAX;
  if (long_diff < -ACCELMAX)
    long_diff = -ACCELMAX;
  if (lat_diff > ACCELMAX)
    lat_diff = ACCELMAX;
  if (lat_diff < -ACCELMAX)
    lat_diff = -ACCELMAX;
  current_lat += lat_diff;
  current_long += long_diff;
  secs = g_timer_elapsed (timer, 0);
  if (secs >= 1.0)
    {
      g_timer_stop (timer);
      g_timer_start (timer);
      tx =
	(2 * R * M_PI / 360) * cos (M_PI * current_lat / 180.0) *
	(current_long - old_long);
      ty = (2 * R * M_PI / 360) * (current_lat - old_lat);
#define MINSPEED 1.0
      if (((fabs (tx)) > MINSPEED) || (((fabs (ty)) > MINSPEED)))
	{
	  if (ty == 0)
	    direction = 0.0;
	  else
	    direction = atan (tx / ty);
	  if (ty < 0)
	    direction = M_PI + direction;
	  if (direction >= (2 * M_PI))
	    direction -= 2 * M_PI;
	  if (direction < 0)
	    direction += 2 * M_PI;
	  groundspeed = milesconv * sqrt (tx * tx + ty * ty) * 3.6 / secs;
	}
      else
	groundspeed = 0.0;
      if (groundspeed > 9999)
	groundspeed = 9999;
      old_lat = current_lat;
      old_long = current_long;
      if (debug)
	g_print ("\nTime: %f", secs);
    }

  return TRUE;
}


/*  open serial port or pty master or file for NMEA output */
FILE *
opennmea (const char *name)
{
  struct termios tios;
  FILE *const out = fopen (name, "w");
  if (out == NULL)
    {
      perror (_("can't open NMEA output file"));
      exit (1);
    }

  if (tcgetattr (fileno (out), &tios))
    return out;			/* not a terminal, oh well */

  tios.c_iflag = 0;
  tios.c_oflag = 0;
  tios.c_cflag = CS8 | CLOCAL;
  tios.c_lflag = 0;
  tios.c_cc[VMIN] = 1;
  tios.c_cc[VTIME] = 0;
  cfsetospeed (&tios, B4800);
  tcsetattr (fileno (out), TCSAFLUSH, &tios);
  return out;
}

void
write_nmea_line (const char *line)
{
  int checksum = 0;
  fprintf (nmeaout, "$%s*", line);
  while ('\0' != *line)
    checksum = checksum ^ *line++;
  fprintf (nmeaout, "%02X\r\n", checksum);
  fflush (nmeaout);
}

void
gen_nmea_coord (char *out)
{
  gdouble lat = fabs (current_lat), lon = fabs (current_long);
  sprintf (out, ",%02d%07.5f,%c,%03d%07.5f,%c",
	   (int) floor (lat), 60 * (lat - floor (lat)),
	   (current_lat < 0 ? 'S' : 'N'),
	   (int) floor (lon), 60 * (lon - floor (lon)),
	   (current_long < 0 ? 'W' : 'E'));
}

gint
write_nmea_cb (GtkWidget *widget, guint *datum)
{
  char buffer[80];
  time_t now = time (NULL);
  struct tm *st = gmtime (&now);

  strftime (buffer, sizeof (buffer), "GPGGA,%H%M%S.000", st);
  gen_nmea_coord (buffer + strlen (buffer));
  strcpy (buffer + strlen (buffer), ",1,00,0.0,,M,,,,0000");
  write_nmea_line (buffer);

  strcpy (buffer, "GPGLL");
  gen_nmea_coord (buffer + strlen (buffer));
  strftime (buffer + strlen (buffer), 80, ",%H%M%S.000,A", st);
  write_nmea_line (buffer);

  strftime (buffer, sizeof (buffer), "GPRMC,%H%M%S.000,A", st);
  gen_nmea_coord (buffer + strlen (buffer));
  sprintf (buffer + strlen (buffer), ",%.2f,%.2f",
	   groundspeed / milesconv / 1.852, direction * 180.0 / M_PI);
  strftime (buffer + strlen (buffer), 80, ",%d%m%y,,", st);
  write_nmea_line (buffer);

  sprintf (buffer, "GPVTG,%.2f,T,,M,%.2f,N,%.2f,K",
	   direction * 180.0 / M_PI,
	   groundspeed / milesconv / 1.852, groundspeed / milesconv);
  write_nmea_line (buffer);

  return TRUE;
}


/*  We load the map */
void
loadmap (char *filename)
{
  gchar mappath[400];

  if (maploaded)
    gdk_pixbuf_unref (image);
  strcpy (mappath, homedir);
  strcat (mappath, filename);
  image = gdk_pixbuf_new_from_file (mappath);
  if (image == NULL)
    {
      GString *error;
      error = g_string_new (NULL);
      g_string_sprintf (error, "\n%s\n%s\n",
			_(" Mapfile could not be loaded:"), mappath);
      error_popup ((gpointer *) error->str);
      g_string_free (error, TRUE);
      maploaded = FALSE;
    }
  else
    {
      expose_cb (NULL, NULL);
      iszoomed = FALSE;
/*        zoom = 1; */
      xoff = yoff = 0;
      rebuildtracklist ();
      maploaded = TRUE;
/*  draw minimap */
      if (miniimage)
	gdk_pixbuf_unref (miniimage);
      miniimage = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 0, 8, 128, 103);
      gdk_pixbuf_scale (image, miniimage, 0, 0, 128, 103,
			0, 0, 0.1, 0.10, GDK_INTERP_TILES);
/*  draw the minimap */
/*        gdk_pixbuf_render_to_drawable (miniimage, drawing_area4->window, */
/*  				     kontext, 0, 0, 0, 0, 128, 103, */
/*  				     GDK_RGB_DITHER_NONE, 0, 0); */
      exposemini_cb (NULL, 0);

    }

}


void
loadfriendsicon (void)
{
  gchar mappath[400];

  sprintf (mappath, "%s/%s", DATADIR, "friendsicon.png");
  friendsimage = gdk_pixbuf_new_from_file (mappath);
  if (friendsimage == NULL)
    {
      friendsimage = gdk_pixbuf_new_from_file ("friendsicon.png");
    }
  if (friendsimage == NULL)
    {
      GString *error;
      error = g_string_new (NULL);
      g_string_sprintf (error, "\n%s\n%s\n",
			_(" Friendsicon could not be loaded:"), mappath);
      error_popup ((gpointer *) error->str);
      g_string_free (error, TRUE);
    }
  else
    {
      g_print ("\n%s\n", _("Friendsicon loaded"));
    }
  friendspixbuf = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 1, 8, 37, 37);
  gdk_pixbuf_scale (friendsimage, friendspixbuf, 0, 0, 37, 37,
		    0, 0, 1, 1, GDK_INTERP_BILINEAR);

}

gint
zoom_cb (GtkWidget *widget, guint datum)
{

  if (iszoomed == FALSE)	/* needed to be sure the old zoom is made */
    return TRUE;
  iszoomed = FALSE;
  if (datum == 1)
    {
      if (zoom >= 16)
	{
	  iszoomed = TRUE;
	  return TRUE;
	}
      zoom *= 2;
      xoff *= 2;
      yoff *= 2;
    }
  else
    {
      if (zoom <= 1)
	{
	  zoom = 1;
	  iszoomed = TRUE;
	}
      else
	{
	  zoom /= 2;
	  xoff /= 2;
	  yoff /= 2;
	}
    }
  if (importactive)
    {
      expose_cb (NULL, 0);
      exposemini_cb (NULL, 0);
    }
  return TRUE;
}


gint
scalerbt_cb (GtkWidget *widget, guint datum)
{
  gint val, oldval, old2val;
  gchar oldfilename[200];

  strcpy (oldfilename, mapfilename);
  val = (GTK_ADJUSTMENT (adj)->value);
  old2val = val;

  do
    {
      oldval = val;
      if (datum == 1)
	{
	  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val + 1);
	}
      else
	{
	  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val - 1);
	}
      val = (GTK_ADJUSTMENT (adj)->value);

      testnewmap ();
    }
  while (((strcmp (oldfilename, mapfilename)) == 0) && (val != oldval));

  if ((strcmp (oldfilename, mapfilename)) == 0)
    val = old2val;
  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val);
  expose_cb (NULL, 0);
  exposemini_cb (NULL, 0);


  return TRUE;
}


/*  destroy sel_target window */
gint
sel_targetweg_cb (GtkWidget *widget, guint datum)
{
  gtk_widget_destroy (GTK_WIDGET (gotowindow));
  return FALSE;
}

gint
dlstatusaway_cb (GtkWidget *widget, guint datum)
{
  downloadwindowactive = downloadactive = FALSE;
  return FALSE;
}

gint
importaway_cb (GtkWidget *widget, guint datum)
{
  importactive = FALSE;
  gtk_widget_destroy (widget);
  strcpy (oldfilename, "XXXXXXXXXXXXXXXXXX");
  return FALSE;
}

/*  cancel button pressed or widget destroy in download_cb */
gint
downloadaway_cb (GtkWidget *widget, guint datum)
{
  downloadwindowactive = downloadactive = FALSE;
  gtk_widget_destroy (widget);
/*    gdk_window_set_cursor (drawing_area->window, 0); */
/*    gdk_cursor_destroy (cursor); */
  return FALSE;
}


gint
testnewwp_cb (GtkWidget *widget, guint datum)
{
  gint e;
  e = kill (datum, 0);
  if (e != 0)
    {
      loadwaypoints ();
      return FALSE;
    }
  return TRUE;
}

/*  load waypoints from GARMIN gps */
/*  doesn't work! */

gint
downloadwp_cb (GtkWidget *widget, guint datum)
{
  gint pd, e;
  gchar args[100][2];
  pd = fork ();
  if (pd == 0)			/* I'm the child */
    {
      strcpy (args[0], "/bin/sh");
      strcpy (args[1], "wpget");
      e = execl ("sh", args[0], args[1], NULL);
      perror ("\nError calling wpget!!!\n");
    }

  gtk_timeout_add (500, (GtkFunction) testnewwp_cb, (gpointer) pd);
  return TRUE;
}

gint
download_cb (GtkWidget *widget, guint datum)
{
  GtkWidget *mainbox;
  GtkWidget *knopf2, *knopf, *knopf3, *knopf4, *knopf5, *knopf6, *knopf7;
  GtkWidget *table;
  gchar buff[300];
  GList *list = NULL;
  GSList *gr;
  gint i, e;
  struct stat buf;
  for (i = 0; i < 30; i++)
    list = g_list_append (list, slist[i]);
  downloadwindow = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (downloadwindow),
			_("Select coordinates and scale"));
  gtk_container_set_border_width (GTK_CONTAINER (downloadwindow), 5);
  mainbox = gtk_vbox_new (TRUE, 2);
  knopf = gtk_button_new_with_label (_("Download map"));
  gtk_signal_connect_object (GTK_OBJECT (knopf), "clicked",
			     GTK_SIGNAL_FUNC
			     (downloadsetparm), GTK_OBJECT (downloadwindow));
  knopf2 = gtk_button_new_with_label (_("Cancel"));
  gtk_signal_connect_object (GTK_OBJECT (knopf2), "clicked",
			     GTK_SIGNAL_FUNC
			     (downloadaway_cb), GTK_OBJECT (downloadwindow));
  gtk_signal_connect_object (GTK_OBJECT (downloadwindow), "delete_event",
			     GTK_SIGNAL_FUNC (downloadaway_cb),
			     GTK_OBJECT (downloadwindow));

  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (downloadwindow)->
		       action_area), knopf, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (downloadwindow)->
		       action_area), knopf2, TRUE, TRUE, 2);
  GTK_WIDGET_SET_FLAGS (knopf, GTK_CAN_DEFAULT);
  GTK_WIDGET_SET_FLAGS (knopf2, GTK_CAN_DEFAULT);
  table = gtk_table_new (7, 2, FALSE);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (downloadwindow)->vbox),
		      table, TRUE, TRUE, 2);
  knopf3 = gtk_label_new (_("Latitude"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf3, 0, 1, 0, 1);
  knopf4 = gtk_label_new (_("Longitude"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf4, 0, 1, 1, 2);
  knopf5 = gtk_label_new (_("Scale"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf5, 0, 1, 2, 3);
  knopf6 = gtk_label_new (_("Map file name"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf6, 0, 1, 3, 4);
  dltext1 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext1, 1, 2, 0, 1);
  sprintf (buff, "%.5f", current_lat);
  gtk_entry_set_text (GTK_ENTRY (dltext1), buff);
  dltext2 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext2, 1, 2, 1, 2);
  sprintf (buff, "%.5f", current_long);
  gtk_entry_set_text (GTK_ENTRY (dltext2), buff);
  dltext3 = gtk_combo_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext3, 1, 2, 2, 3);
  gtk_combo_set_popdown_strings (GTK_COMBO (dltext3), (GList *) list);
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (dltext3)->entry), "50000");
  dltext4 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext4, 1, 2, 3, 4);

  radio1 = gtk_radio_button_new_with_label (NULL, "Mapblast server");
  gtk_table_attach_defaults (GTK_TABLE (table), radio1, 0, 1, 4, 5);
  gr = gtk_radio_button_group (GTK_RADIO_BUTTON (radio1));
  radio2 = gtk_radio_button_new_with_label (gr, "Expedia  server");
  gtk_table_attach_defaults (GTK_TABLE (table), radio2, 1, 2, 4, 5);

/*  expedia did not work yet */
/*    gtk_widget_set_sensitive (radio2, FALSE); */


  if (!haveproxy)
    sprintf (buff, "%s", _("You can also select the position\n"
			   "with a mouse click on the map."));
  else
    sprintf (buff, "%s\n\n%s    %s %d", _("You can also select the position\n"
					  "with a mouse click on the map."),
	     _("Using Proxy and port:"), proxy, proxyport);
  knopf7 = gtk_label_new (buff);
  gtk_table_attach_defaults (GTK_TABLE (table), knopf7, 0, 2, 5, 6);
  myprogress = gtk_progress_bar_new ();
  style = gtk_style_copy (gtk_widget_get_style (myprogress));
  style->bg[GTK_STATE_PRELIGHT] = blue;
  style->fg[GTK_STATE_PRELIGHT] = white;
  gtk_widget_set_style (myprogress, style);
  gtk_progress_set_format_string (GTK_PROGRESS (myprogress), "%p%%");
  gtk_progress_set_show_text (GTK_PROGRESS (myprogress), TRUE);
  gtk_progress_bar_update (GTK_PROGRESS_BAR (myprogress), 0.0);
  gtk_table_attach_defaults (GTK_TABLE (table), myprogress, 0, 2, 6, 7);
  gtk_label_set_justify (GTK_LABEL (knopf6), GTK_JUSTIFY_RIGHT);
  gtk_label_set_justify (GTK_LABEL (knopf3), GTK_JUSTIFY_RIGHT);
  gtk_label_set_justify (GTK_LABEL (knopf4), GTK_JUSTIFY_RIGHT);
  gtk_label_set_justify (GTK_LABEL (knopf5), GTK_JUSTIFY_RIGHT);
  gtk_label_set_justify (GTK_LABEL (knopf6), GTK_JUSTIFY_RIGHT);
  i = 0;
  do
    {
      sprintf (downloadfilename, "%smap_file%04d.gif", homedir, i++);
      e = stat (downloadfilename, &buf);
    }
  while (e == 0);
  sprintf (buff, "map_file%04d.gif", i - 1);
  gtk_entry_set_text (GTK_ENTRY (dltext4), buff);
  gtk_window_set_default (GTK_WINDOW (downloadwindow), knopf);
  gtk_window_set_transient_for (GTK_WINDOW (downloadwindow),
				GTK_WINDOW (mainwindow));
  gtk_window_set_position (GTK_WINDOW (downloadwindow), GTK_WIN_POS_CENTER);
  gtk_widget_show_all (downloadwindow);
  downloadwindowactive = TRUE;
/*    cursor = gdk_cursor_new (GDK_CROSS); */
/*    gdk_window_set_cursor (drawing_area->window, cursor); */
  return TRUE;
}

gint
downloadsetparm (GtkWidget *widget, guint datum)
{
  gchar *s, longi[100], lat[100], *sc;
  gdouble f;
  gint ns;

  if (GTK_TOGGLE_BUTTON (radio2)->active)
    expedia = TRUE;
  else
    expedia = FALSE;

  s = gtk_entry_get_text (GTK_ENTRY (dltext1));
  strcpy (lat, s);
  strcpy (newmaplat, s);
  g_strdelimit (lat, ",", '.');
  s = gtk_entry_get_text (GTK_ENTRY (dltext2));
  strcpy (longi, s);
  strcpy (newmaplongi, s);
  g_strdelimit (longi, ",", '.');
  sc = gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (dltext3)->entry));
  strcpy (newmapsc, sc);
  if (expedia)
    {
      f = g_strtod (sc, NULL);
      ns = f / EXPEDIAFACT;
      sprintf (sc, "%d", ns);
      sprintf (newmapsc, "%d", (int) (ns * EXPEDIAFACT));
    }
  if (!expedia)
    sprintf (writebuff,
	     "GET http://%s/gif?&CT=%s%%3A%s%%3A%s&IC=&W=1280&H=1024&FAM=mblast&LB= HTTP/1.0\nUser-Agent: Wget/1.6\nHost: %s\nAccept: */*\n\n",
	     WEBSERVER, lat, longi, sc, hostname);
  else
    sprintf (writebuff,
	     "GET http://%s/isapi/MSMap.dll?ID=3XNsF.&C=%s,%s&L=EUR0809&CV=1&A=%s&S=1280,1024&O=0.000000,0.000000&MS=0&P=|5748| HTTP/1.0\nUser-Agent: Wget/1.6\nHost: %s\nAccept: */*\n\n",
	     WEBSERVER2, lat, longi, sc, hostname);
  downloadstart_cb (widget, 0);
  return TRUE;
}



gint
downloadstart_cb (GtkWidget *widget, guint datum)
{
  struct sockaddr_in server;
  struct hostent *server_data;
  gchar str[100], sn[1000];


  downloadfilelen = 0;
  downloadactive = TRUE;
  sprintf (str, _("Connecting to %s"), (expedia) ? WEBSERVER2 : WEBSERVER);
  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
  gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
  while (gtk_events_pending ())
    gtk_main_iteration ();
/*  open socket to port80 */
  if ((dlsock = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror (_("can't open socket for port 80"));
      sprintf (str, _("Connecting to %s FAILED!"),
	       (expedia) ? WEBSERVER2 : WEBSERVER);
      gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
      gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
      gtk_widget_destroy (downloadwindow);
      gtk_timeout_add (6000, (GtkFunction) dlstatusaway_cb, widget);
      return (FALSE);
    }

  server.sin_family = AF_INET;
/*  We retrieve the IP address of the server from its name: */
  if (haveproxy)
    strcpy (sn, proxy);
  else
    strcpy (sn, (expedia) ? WEBSERVER2 : WEBSERVER);

  if ((server_data = gethostbyname (sn)) == NULL)
    {
      perror (_("Can't resolve webserver address"));
      sprintf (str, _("Connecting to %s FAILED!"),
	       (expedia) ? WEBSERVER2 : WEBSERVER);
      gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
      gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
      gtk_widget_destroy (downloadwindow);
      gtk_timeout_add (3000, (GtkFunction) dlstatusaway_cb, widget);
      return (FALSE);
    }
  memcpy (&server.sin_addr, server_data->h_addr, server_data->h_length);
  server.sin_port = htons (proxyport);
/*  We initiate the connection  */
  if (connect (dlsock, (struct sockaddr *) &server, sizeof server) < 0)
    {
      perror (_("unable to connect to Website"));
      sprintf (str, _("Connecting to %s FAILED!"),
	       (expedia) ? WEBSERVER2 : WEBSERVER);
      gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
      gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
      gtk_widget_destroy (downloadwindow);
      gtk_timeout_add (3000, (GtkFunction) dlstatusaway_cb, widget);
      return (FALSE);
    }

#define LOCALTESTSTRINGXXX
#ifdef LOCALTESTSTRING
  sprintf (writebuff,
	   "GET /apollo17.gif HTTP/1.0\nUser-Agent: Wget/1.6\nHost: wuffi.grazforyou.at\nAccept:*/*\n\n");
#endif
  write (dlsock, writebuff, strlen (writebuff));
  dlbuff = g_new0 (gchar, 8192);
  dlpstart = NULL;
  dldiff = dlcount = 0;
  sprintf (str, _("Now connected to %s"), (expedia) ? WEBSERVER2 : WEBSERVER);
  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
  gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
  gtk_timeout_add (100, (GtkFunction) downloadslave_cb, widget);
  return TRUE;
}

gint
downloadslave_cb (GtkWidget *widget, guint datum)
{
  gchar tmpbuff[9000], str[100], *p;
  gint e, fd;
  gchar nn[] = "\r\n\r\n";
  gdouble f;
  if (!downloadwindowactive)
    return FALSE;
  FD_ZERO (&readmask);
  FD_SET (dlsock, &readmask);
  timeout.tv_sec = 0;
  timeout.tv_usec = 100000;
  if (select (FD_SETSIZE, &readmask, NULL, NULL, &timeout) < 0)
    {
      perror ("select() call");
    }

  if (FD_ISSET (dlsock, &readmask))
    {

      memset (tmpbuff, 0, 8192);
      if ((e = read (dlsock, tmpbuff, 8000)) < 0)
	perror (_("read from Webserver"));
      if (debug)
	g_print ("\nLoaded %d Bytes\n", e);
      if (e > 0)
	{
/*  in dlbuff we have all download data */
	  memcpy ((dlbuff + dlcount), tmpbuff, e);
/*  in dlcount we have the number of download bytes */
	  dlcount += e;
/* now we try to get the filelength and begin of the gif image data */
	  if (dlpstart == NULL)
	    {
/*  CONTENT-LENGTH string should hopefully be in the first 4kB */
	      memcpy (tmpbuff, dlbuff, 4096);
/*  We make of this a null terminated string */
	      tmpbuff[4096] = 0;
	      g_strup (tmpbuff);
	      p = strstr (tmpbuff, "CONTENT-LENGTH:");
	      if (p != NULL)
		{
		  sscanf (p, "%s %d", str, &downloadfilelen);
/*  now we look for 2 cr/lf which is the end of the header */
		  dlpstart = strstr (tmpbuff, nn);
		  dldiff = dlpstart - tmpbuff + 4;
		}
	      else if (dlcount > 1000)
		{
/*  Seems there is no CONTENT-LENGTH field in expedia.com*/
		  dlpstart = strstr (tmpbuff, nn);
		  dldiff = dlpstart - tmpbuff + 4;
		  downloadfilelen = 200000;

		}
	    }
/*  Now we have the length and begin of the gif image data */
	  if ((downloadfilelen != 0) && (dlpstart != NULL))
	    {
	      dlbuff = g_renew (gchar, dlbuff, dlcount + 8192);
	      f = (dlcount - dldiff) / (gdouble) downloadfilelen;
	      gtk_progress_bar_update (GTK_PROGRESS_BAR (myprogress), f);
	      sprintf (str, _("Downloaded %d kBytes"),
		       (dlcount - dldiff) / 1024);
	      gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
	      gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
	      while (gtk_events_pending ())
		gtk_main_iteration ();
	    }

	}
      if (e == 0)
	{
	  if (downloadfilelen == 0)
	    sprintf (str, _("Download FAILED!"));
	  else
	    sprintf (str, _("Download finished, got %dkB"), dlcount / 1024);
	  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
	  gtk_statusbar_push (GTK_STATUSBAR (status), statusid, str);
	  close (dlsock);
	  if (downloadfilelen != 0)
	    {
	      fd = open (downloadfilename, O_RDWR | O_TRUNC | O_CREAT, 0644);
	      if (fd < 1)
		{
		  perror (downloadfilename);
		  gtk_timeout_add (3000, (GtkFunction) dlstatusaway_cb,
				   widget);
		  return FALSE;
		}
	      write (fd, dlbuff + dldiff, dlcount - dldiff);
	      close (fd);
	      g_free (maps);
	      loadmapconfig ();
	      maps =
		g_renew (mapsstruct, maps,
			 (nrmaps + 1) * sizeof (mapsstruct));
	      strcpy ((maps + nrmaps)->filename,
		      g_basename (downloadfilename));
	      (maps + nrmaps)->lat = g_strtod (newmaplat, NULL);
	      (maps + nrmaps)->longitude = g_strtod (newmaplongi, NULL);
	      (maps + nrmaps)->scale = strtol (newmapsc, NULL, 0);
	      nrmaps++;
	      savemapconfig ();
	    }
	  downloadwindowactive = FALSE;
	  gtk_widget_destroy (downloadwindow);
	  gtk_timeout_add (3000, (GtkFunction) dlstatusaway_cb, widget);
	  return FALSE;
	}
    }
  else
    return TRUE;
  return TRUE;
}

gint
import2_cb (GtkWidget *widget, gpointer datum)
{
  gchar *s;

  s = gtk_entry_get_text (GTK_ENTRY (dltext1));
  imports[0].lat = g_strtod (s, NULL);
  s = gtk_entry_get_text (GTK_ENTRY (dltext2));
  imports[0].lon = g_strtod (s, NULL);
  s = gtk_entry_get_text (GTK_ENTRY (dltext5));
  imports[0].x = strtol (s, NULL, 0);
  s = gtk_entry_get_text (GTK_ENTRY (dltext6));
  imports[0].y = strtol (s, NULL, 0);

  gtk_widget_destroy (widget);
  import1_cb (NULL, 2);
  return TRUE;
}

gint
import3_cb (GtkWidget *widget, gpointer datum)
{
  gchar *s;
  gdouble tx, ty, scale, latmax, latmin, latcenter, longmax, longmin;
  gdouble longcenter;
  gdouble px, py;

  s = gtk_entry_get_text (GTK_ENTRY (dltext1));
  imports[1].lat = g_strtod (s, NULL);
  s = gtk_entry_get_text (GTK_ENTRY (dltext2));
  imports[1].lon = g_strtod (s, NULL);
  s = gtk_entry_get_text (GTK_ENTRY (dltext5));
  imports[1].x = strtol (s, NULL, 0);
  s = gtk_entry_get_text (GTK_ENTRY (dltext6));
  imports[1].y = strtol (s, NULL, 0);
  gtk_widget_destroy (widget);

/*  Calc coordinates and scale */

  tx =
    (2 * R * M_PI / 360) * cos (M_PI * imports[0].lat / 180.0) *
    (imports[0].lon - imports[1].lon);
  ty = (2 * R * M_PI / 360) * (imports[0].lat - imports[1].lat);
/*  ty is meter */
  px = abs (imports[0].x - imports[1].x);
  py = abs (imports[0].y - imports[1].y);
  if (px > py)
    scale = fabs (tx) * PIXELFACT / px;
  else
    scale = fabs (ty) * PIXELFACT / py;
  px = imports[0].x - imports[1].x;
  py = imports[0].y - imports[1].y;
  py = -py;

  latmin =
    imports[0].lat - (imports[0].lat - imports[1].lat) * (1024 -
							  imports[0].y) / py;
  latmax = latmin + (imports[0].lat - imports[1].lat) * 1024.0 / py;
  latcenter = (latmax + latmin) / 2.0;

  longmin =
    imports[0].lon - imports[0].x * (imports[0].lon - imports[1].lon) / px;

  longmax = longmin + 1280.0 * (imports[0].lon - imports[1].lon) / px;
  longcenter = (longmax + longmin) / 2.0;

  if (debug)
    g_print
      ("\nScale: %g, latmitte: %g, latmin: %g, "
       "latmax: %g\n longmin: %g, longmax: %g, longmitte: %g\n",
       scale, latcenter, latmin, latmax, longmin, longmax, longcenter);

  if (strlen (importfilename) > 4)
    {
      maps = g_renew (mapsstruct, maps, (nrmaps + 1) * sizeof (mapsstruct));
      strcpy ((maps + nrmaps)->filename, importfilename);
      (maps + nrmaps)->lat = latcenter;
      (maps + nrmaps)->longitude = longcenter;
      (maps + nrmaps)->scale = scale;
      nrmaps++;
      savemapconfig ();
    }

  importactive = FALSE;
  strcpy (oldfilename, "XXXAFHSGFAERGXXXXXX");
  return TRUE;
}


gint
nimmfile (GtkWidget *widget, gpointer datum)
{
  gchar *buf;

  buf = gtk_file_selection_get_filename (datum);
  gtk_entry_set_text (GTK_ENTRY (dltext7), g_basename (buf));
  strcpy (importfilename, g_basename (buf));

  gtk_widget_destroy (datum);
  loadmap (g_basename (buf));
  return (TRUE);
}

gint
importfb_cb (GtkWidget *widget, guint datum)
{
  GtkWidget *fdialog;
  gchar buf[1000];
  fdialog = gtk_file_selection_new (_("Select a map file"));
  gtk_window_set_modal (GTK_WINDOW (fdialog), TRUE);

  gtk_signal_connect (GTK_OBJECT
		      (GTK_FILE_SELECTION (fdialog)->ok_button),
		      "clicked", GTK_SIGNAL_FUNC (nimmfile),
		      GTK_OBJECT (fdialog));
  gtk_signal_connect_object (GTK_OBJECT
			     (GTK_FILE_SELECTION (fdialog)->
			      cancel_button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fdialog));


  strcpy (buf, homedir);
  strcat (buf, "");
  gtk_file_selection_complete (GTK_FILE_SELECTION (fdialog), buf);
  gtk_widget_show (fdialog);
  xoff = 0;
  yoff = 0;
  zoom = 1;
  iszoomed = FALSE;

  return TRUE;
}


gint
importshift_cb (GtkWidget *widget, guint datum)
{
  switch (datum)
    {
    case 1:
      yoff -= SCREEN_Y_2;
      break;
    case 4:
      yoff += SCREEN_Y_2;
      break;
    case 2:
      xoff -= SCREEN_X_2;
      break;
    case 3:
      xoff += SCREEN_X_2;
      break;
    }
  iszoomed = FALSE;
  expose_cb (NULL, 0);
  exposemini_cb (NULL, 0);

  return TRUE;
}


gint
import1_cb (GtkWidget *widget, guint datum)
{
  GtkWidget *mainbox, *window;
  GtkWidget *knopf2, *knopf, *knopf3, *knopf4, *knopf6;
  GtkWidget *table, *knopf9, *knopf10, *knopf11, *s1, *s2, *s3, *s4;
  GtkWidget *s5, *s6;
  gchar buff[300];
  GtkWidget *text;
  GtkWidget *scrollbar;
  GtkWidget *hbox;
  gchar *thetext1 = _("How to calibrate your own maps?\n\n"
		      "First, the map file must be copied into the ~/.gpsdrive"
		      " directory as .gif, .jpg or .png file "
		      "and must have the size 1280x1024. The file names must be "
		      "map_* for street maps or top_* for topographical maps!"
		      "\nLoad the file, select coordinates\n"
		      "from waypoint list or type them in.\n"
		      "Then click on the accept button.");
  gchar *thetext2 =
    _("Now do the same for your second point and click on the"
      "finish button. The map can be used now.");

  window = gtk_dialog_new ();
  if (datum == 1)
    gtk_window_set_title (GTK_WINDOW (window), _("Import Assistent. Step 1"));
  else
    gtk_window_set_title (GTK_WINDOW (window), _("Import Assistent. Step 2"));

  gtk_container_set_border_width (GTK_CONTAINER (window), 5);
  mainbox = gtk_vbox_new (TRUE, 2);
  if (datum == 1)
    knopf = gtk_button_new_with_label (_("Accept first point"));
  else
    knopf = gtk_button_new_with_label (_("Finish"));
  if (datum == 1)
    gtk_signal_connect_object (GTK_OBJECT (knopf), "clicked",
			       GTK_SIGNAL_FUNC (import2_cb),
			       GTK_OBJECT (window));
  else
    {
      gtk_signal_connect_object (GTK_OBJECT (knopf), "clicked",
				 GTK_SIGNAL_FUNC (import3_cb),
				 GTK_OBJECT (window));
    }

  knopf2 = gtk_button_new_with_label (_("Cancel"));
  gtk_signal_connect_object (GTK_OBJECT (knopf2), "clicked",
			     GTK_SIGNAL_FUNC
			     (importaway_cb), GTK_OBJECT (window));
  gtk_signal_connect_object (GTK_OBJECT (window),
			     "delete_event",
			     GTK_SIGNAL_FUNC
			     (importaway_cb), GTK_OBJECT (window));

  s1 = gtk_button_new_with_label (_("Go up"));
  gtk_signal_connect (GTK_OBJECT (s1), "clicked",
		      GTK_SIGNAL_FUNC (importshift_cb), (gpointer) 1);
  s2 = gtk_button_new_with_label (_("Go left"));
  gtk_signal_connect (GTK_OBJECT (s2), "clicked",
		      GTK_SIGNAL_FUNC (importshift_cb), (gpointer) 2);
  s3 = gtk_button_new_with_label (_("Go right"));
  gtk_signal_connect (GTK_OBJECT (s3), "clicked",
		      GTK_SIGNAL_FUNC (importshift_cb), (gpointer) 3);
  s4 = gtk_button_new_with_label (_("Go down"));
  gtk_signal_connect (GTK_OBJECT (s4), "clicked",
		      GTK_SIGNAL_FUNC (importshift_cb), (gpointer) 4);
  s5 = gtk_button_new_with_label (_("Zoom in"));
  gtk_signal_connect (GTK_OBJECT (s5), "clicked",
		      GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 1);
  s6 = gtk_button_new_with_label (_("Zoom out"));
  gtk_signal_connect (GTK_OBJECT (s6), "clicked",
		      GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 2);

  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->
		       action_area), knopf, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->
		       action_area), knopf2, TRUE, TRUE, 2);
  GTK_WIDGET_SET_FLAGS (knopf, GTK_CAN_DEFAULT);
  GTK_WIDGET_SET_FLAGS (knopf2, GTK_CAN_DEFAULT);
  table = gtk_table_new (6, 4, TRUE);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->vbox), table, TRUE, TRUE, 2);
  knopf3 = gtk_label_new (_("Latitude"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf3, 0, 1, 0, 1);
  knopf4 = gtk_label_new (_("Longitude"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf4, 0, 1, 1, 2);
  knopf9 = gtk_label_new (_("Screen X"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf9, 2, 3, 0, 1);
  knopf10 = gtk_label_new (_("Screen Y"));
  gtk_table_attach_defaults (GTK_TABLE (table), knopf10, 2, 3, 1, 2);
  knopf6 = gtk_button_new_with_label (_("Browse waypoint"));
  gtk_signal_connect (GTK_OBJECT (knopf6), "clicked",
		      GTK_SIGNAL_FUNC (sel_target_cb), (gpointer) 1);

  gtk_table_attach_defaults (GTK_TABLE (table), knopf6, 0, 1, 2, 3);
  dltext1 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext1, 1, 2, 0, 1);
  sprintf (buff, "%.5f", current_lat);
  gtk_entry_set_text (GTK_ENTRY (dltext1), buff);
  dltext2 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext2, 1, 2, 1, 2);
  sprintf (buff, "%.5f", current_long);
  gtk_entry_set_text (GTK_ENTRY (dltext2), buff);

  dltext5 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext5, 3, 4, 0, 1);

  dltext6 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext6, 3, 4, 1, 2);

  dltext4 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext4, 1, 2, 2, 3);
  dltext7 = gtk_entry_new ();
  gtk_table_attach_defaults (GTK_TABLE (table), dltext7, 3, 4, 2, 3);

  if (datum == 1)
    {
      knopf11 = gtk_button_new_with_label (_("Browse filename"));
      gtk_signal_connect_object (GTK_OBJECT (knopf11), "clicked",
				 GTK_SIGNAL_FUNC (importfb_cb), 0);
      gtk_table_attach_defaults (GTK_TABLE (table), knopf11, 2, 3, 2, 3);
    }
  else
    gtk_entry_set_text (GTK_ENTRY (dltext7), importfilename);


  gtk_entry_set_editable (GTK_ENTRY (dltext7), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (dltext4), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (dltext5), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (dltext6), FALSE);
  text = gtk_text_new (NULL, NULL);
  gtk_widget_set_usize (text, 100, 80);
  gtk_text_set_line_wrap (GTK_TEXT (text), TRUE);
  gtk_text_set_word_wrap (GTK_TEXT (text), TRUE);
  scrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  if (datum == 1)
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, thetext1, -1);
  else
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, thetext2, -1);

  hbox = gtk_hbox_new (FALSE, 3);
  gtk_box_pack_start (GTK_BOX (hbox), text, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), scrollbar, FALSE, FALSE, 0);

  gtk_table_attach_defaults (GTK_TABLE (table), hbox, 2, 4, 3, 6);
  gtk_table_attach_defaults (GTK_TABLE (table), s1, 0, 1, 3, 4);
  gtk_table_attach_defaults (GTK_TABLE (table), s5, 1, 2, 3, 4);
  gtk_table_attach_defaults (GTK_TABLE (table), s2, 0, 1, 4, 5);
  gtk_table_attach_defaults (GTK_TABLE (table), s3, 1, 2, 4, 5);
  gtk_table_attach_defaults (GTK_TABLE (table), s4, 0, 1, 5, 6);
  gtk_table_attach_defaults (GTK_TABLE (table), s6, 1, 2, 5, 6);
  gtk_table_set_row_spacings (GTK_TABLE (table), 3);
  gtk_table_set_col_spacings (GTK_TABLE (table), 3);
/*    gtk_label_set_justify (GTK_LABEL (knopf6), GTK_JUSTIFY_RIGHT); */
/*    gtk_label_set_justify (GTK_LABEL (knopf3), GTK_JUSTIFY_RIGHT); */
/*    gtk_label_set_justify (GTK_LABEL (knopf4), GTK_JUSTIFY_RIGHT); */
/*    gtk_label_set_justify (GTK_LABEL (knopf6), GTK_JUSTIFY_RIGHT); */
  gtk_window_set_default (GTK_WINDOW (window), knopf);
  gtk_window_set_transient_for (GTK_WINDOW (window), GTK_WINDOW (mainwindow));
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_widget_show_all (window);
  importactive = TRUE;

  return TRUE;
}


/*  switching between kilometers and miles */
gint
miles_cb (GtkWidget *widget, guint datum)
{
  if (milesflag)		/* switch to kilometers */
    {
      milesconv = 1.0;
      milesflag = FALSE;
    }
  else				/* switch to miles */
    {
      milesconv = KM2MILES;
      milesflag = TRUE;
    }

  return TRUE;
}

gint
maptoggle_cb (GtkWidget *widget, guint datum)
{
  displaymap_map = !displaymap_map;
  if (displaymap_map)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), FALSE);
  return TRUE;
}

gint
bestmap_cb (GtkWidget *widget, guint datum)
{
  scaleprefered = !scaleprefered;
  if (!scaleprefered)
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), TRUE);
      gtk_widget_set_sensitive (scalerrbt, FALSE);
      gtk_widget_set_sensitive (scalerlbt, FALSE);
      gtk_widget_set_sensitive (scaler, FALSE);
    }
  else
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), FALSE);
      gtk_widget_set_sensitive (scalerrbt, TRUE);
      gtk_widget_set_sensitive (scalerlbt, TRUE);
      gtk_widget_set_sensitive (scaler, TRUE);
    }
  return TRUE;
}

gint
savetrack_cb (GtkWidget *widget, guint datum)
{
  savetrack = !savetrack;
  if (savetrack)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (savetrackbt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (savetrackbt), FALSE);
  return TRUE;
}

gint
topotoggle_cb (GtkWidget *widget, guint datum)
{
  displaymap_top = !displaymap_top;
  if (displaymap_top)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), FALSE);
  return TRUE;
}


gint
mute_cb (GtkWidget *widget, guint datum)
{
  muteflag = !muteflag;
  if (muteflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mutebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mutebt), FALSE);
  return TRUE;
}

gint
track_cb (GtkWidget *widget, guint datum)
{
  trackflag = !trackflag;
  if (trackflag)
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), TRUE);
      rebuildtracklist ();
    }
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), FALSE);
  return TRUE;
}

gint
wp_cb (GtkWidget *widget, guint datum)
{
  wpflag = !wpflag;
  if (wpflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), FALSE);
  return TRUE;
}

/*  if a waypoint is selected set the target_* variables */
gint
setwp_cb (GtkWidget *widget, guint datum)
{
  gchar b[100], str[200];
  gchar *p;
  p = b;
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 0, &p);
  strcpy (targetname, p);
  sprintf (str, "%s %s", _("Distance to "), targetname);
  gtk_frame_set_label (GTK_FRAME (destframe), str);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 1, &p);
  target_lat = atof (p);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 2, &p);
  target_long = atof (p);
/*    gtk_timeout_add (5000, (GtkFunction) sel_targetweg_cb, widget); */
  g_timer_stop (disttimer);
  g_timer_start (disttimer);
  olddist = dist;
  posmode = FALSE;
  return TRUE;
}

/*  if a waypoint is selected set the target_* variables */
gint
setrefpoint_cb (GtkWidget *widget, guint datum)
{
  gchar b[100];
  gchar *p;
  p = b;
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 0, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext4), p);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 1, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext1), p);

  gtk_clist_get_text (GTK_CLIST (mylist), datum, 2, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext2), p);

  return TRUE;
}



gint
scaler_cb (GtkAdjustment * adj, gdouble *datum)
{
  gchar s2[100];
  scalewanted = nlist[(gint) rint (adj->value)];
  sprintf (s2, "1:%d", scalewanted);
  gtk_label_set_text (GTK_LABEL (l8), s2);
  if (debug)
    g_print ("\nScaler: %d", scalewanted);
  return TRUE;
}

/*  Let user select a destination from the waypoint list */

gint
mapclick_cb (GtkWidget *widget, GdkEventMotion * event)
{
  gint x, y, px, py;
  gdouble dif, lon, lat, vali;
  GdkModifierType state;
  gchar s[200];
  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
    }
  px = (SCREEN_X_2 - x - xoff) * pixelfact / zoom;
  py = (-SCREEN_Y_2 + y + yoff) * pixelfact / zoom;
  lat = zero_lat - py / (Ra[(int) (100 + current_lat)] * M_PI / 180.0);
  lat = zero_lat - py / (Ra[(int) (100 + lat)] * M_PI / 180.0);
  lon =
    zero_long -
    px / ((Ra[(int) (100 + lat)] * M_PI / 180.0) * cos (M_PI * lat / 180.0));

  dif = lat * (1 - (cos ((M_PI * fabs (lon - zero_long)) / 180.0)));
  lat = lat - dif / 1.5;
  lon =
    zero_long -
    px / ((Ra[(int) (100 + lat)] * M_PI / 180.0) * cos (M_PI * lat / 180.0));

  if (downloadwindowactive || importactive)
    {
      if (downloadwindowactive)
	{
	  sprintf (s, "%.5f", lat);
	  gtk_entry_set_text (GTK_ENTRY (dltext1), s);
	  sprintf (s, "%.5f", lon);
	  gtk_entry_set_text (GTK_ENTRY (dltext2), s);
	}
      else
	{
	  sprintf (s, "%d", x + SCREEN_X_2 + xoff);
	  gtk_entry_set_text (GTK_ENTRY (dltext5), s);
	  sprintf (s, "%d", y + SCREEN_Y_2 + yoff);
	  gtk_entry_set_text (GTK_ENTRY (dltext6), s);

	}
    }
  else
    {
/*        g_print ("\nstate: %x x:%d y:%d", state, x, y); */
      vali = (GTK_ADJUSTMENT (adj)->value);
/*  Left mouse button + shift key */
      if ((state & (GDK_BUTTON1_MASK | GDK_SHIFT_MASK)) ==
	  (GDK_BUTTON1_MASK | GDK_SHIFT_MASK))
	{
	  scalerbt_cb (NULL, 2);
	  return TRUE;
	}
/*  Right mouse button + shift key */
      if ((state & (GDK_BUTTON3_MASK | GDK_SHIFT_MASK)) ==
	  (GDK_BUTTON3_MASK | GDK_SHIFT_MASK))
	{
	  scalerbt_cb (NULL, 1);
	  return TRUE;
	}

/*  Left mouse button */
      if ((state & GDK_BUTTON1_MASK) == GDK_BUTTON1_MASK)
	{
	  posmode = TRUE;
	  posmode_x = lon;
	  posmode_y = lat;
	  rebuildtracklist ();
	}
/*  Middle mouse button */
      if ((state & GDK_BUTTON2_MASK) == GDK_BUTTON2_MASK)
	{
	  posmode = FALSE;
	  rebuildtracklist ();
	}
/*  Right mouse button */
      if ((state & GDK_BUTTON3_MASK) == GDK_BUTTON3_MASK)
	{
/* set as target */
/* only if RIGHT mouse button clicked */
	  posmode = FALSE;
	  rebuildtracklist ();
	  strcpy (targetname, _("SELECTED"));
	  sprintf (s, "%s %s", _("Distance to "), targetname);
	  gtk_frame_set_label (GTK_FRAME (destframe), s);
	  target_lat = lat;
	  target_long = lon;
	  g_timer_stop (disttimer);
	  g_timer_start (disttimer);
	  olddist = dist;
	}
    }

/*    g_print ("\nx: %d, y: %d", x, y); */
  return TRUE;
}


gint
sel_target_cb (GtkWidget *widget, guint datum)
{
  GtkWidget *window;
  gchar *tabeltitel1[] = {
    _("Waypoint"), _("Latitude"), _("Longitude"), _("Distance"),
    NULL
  };
  GtkWidget *scrwindow, *vbox, *button;
  gint i, j;
  gchar *text[4], text1[10], text2[10], text3[10], name[40];
  gdouble la, lo, dist;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gotowindow = window;
  if (datum == 1)
    {
      gtk_window_set_modal (GTK_WINDOW (window), TRUE);
      gtk_window_set_title (GTK_WINDOW (window), _("Select reference point"));
    }
  else
    gtk_window_set_title (GTK_WINDOW (window),
			  _("Please select your destination"));
  gtk_window_set_default_size (GTK_WINDOW (window), 280, 300);
  mylist = gtk_clist_new_with_titles (4, tabeltitel1);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 0, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 1, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 2, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 3, TRUE);
  gtk_clist_set_column_justification (GTK_CLIST (mylist), 3,
				      GTK_JUSTIFY_RIGHT);
  thisline = 0;
  if (datum == 1)
    gtk_signal_connect (GTK_OBJECT (GTK_CLIST (mylist)),
			"select-row",
			GTK_SIGNAL_FUNC (setrefpoint_cb),
			GTK_OBJECT (mylist));
  else
    gtk_signal_connect (GTK_OBJECT (GTK_CLIST (mylist)),
			"select-row",
			GTK_SIGNAL_FUNC (setwp_cb), GTK_OBJECT (mylist));
  button = gtk_button_new_with_label (_("Close"));
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_window_set_default (GTK_WINDOW (window), button);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC
			     (gtk_widget_destroy), GTK_OBJECT (window));
  gtk_signal_connect_object (GTK_OBJECT (window),
			     "delete_event",
			     GTK_SIGNAL_FUNC
			     (gtk_widget_destroy), GTK_OBJECT (window));

/*  insert waypoint into the clist */
  for (i = 0; i < maxwp; i++)
    {
      (wayp + i)->dist = calcdist ((wayp + i)->longitude, (wayp + i)->lat);
      text[0] = (wayp + i)->name;
      sprintf (text1, "%8.4f", (wayp + i)->lat);
      sprintf (text2, "%8.4f", (wayp + i)->longitude);
      sprintf (text3, "%9.3f", (wayp + i)->dist);
      text[1] = text1;
      text[2] = text2;
      text[3] = text3;
      j = gtk_clist_append (GTK_CLIST (mylist), (gchar **) text);
      gtk_clist_set_foreground (GTK_CLIST (mylist), j, &black);
    }

  for (i = 0; i < maxfriends; i++)
    {
      strcpy (name, "*");
      strcat (name, friendstxt[i]);
      text[0] = name;
      la = g_strtod (friendslat[i], NULL);
      lo = g_strtod (friendslon[i], NULL);
      sprintf (text1, "%8.4f", la);
      sprintf (text2, "%8.4f", lo);
      text[1] = text1;
      text[2] = text2;
      dist = calcdist (lo, la);
      sprintf (text3, "%9.3f", dist);
      text[3] = text3;
      j = gtk_clist_append (GTK_CLIST (mylist), (gchar **) text);
      gtk_clist_set_foreground (GTK_CLIST (mylist), j, &red);
    }

/*  we want te columns sorted by distance from current position */
  gtk_clist_set_sort_column (GTK_CLIST (mylist), (gint) 3);
  gtk_clist_sort (GTK_CLIST (mylist));
  scrwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (scrwindow), mylist);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
				  (scrwindow),
				  (GtkPolicyType)
				  GTK_POLICY_AUTOMATIC,
				  (GtkPolicyType) GTK_POLICY_AUTOMATIC);
  vbox = gtk_vbox_new (FALSE, 2);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_box_pack_start (GTK_BOX (vbox), scrwindow, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 2);
/*    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER); */
  gtk_widget_show_all (window);
  return TRUE;
}

void
usage ()
{

  g_print ("%s%s%s%s%s%s%s%s%s%s%s%s",
	   "\nCopyright (c) 2001 Fritz Ganter <ganter@ganter.at>"
	   "\n              Website: http://www.kraftvoll.at/software\n\n",
	   _("-v    show version\n"), _("-h    print this help\n"),
	   _("-d    turn on debugging\n"),
	   _("-m    select metric (ignore locale)\n"),
	   _("-t    serial device for GARMIN transfer mode only!\n"
	     "      Default is /dev/gps\n"),
	   _("-o    serial device, pty master, or file for NMEA *output*\n"),
	   _("-f X  Select friends server, X is i.e. linux.quant-x.at\n"),
	   _
	   ("-n X  Select display name on friends server, X is i.e. Fritz\n"),
	   _("-l X  Select language of the voice,\n"
	     "      X may be english, spanish or german\n"),
	   _("-s X  set height of the screen, if autodetection\n"
	     "      don't satisfy you, X is i.e. 768,600,480,200\n"),
	   _("-x    create separate window for menue\n\n"));

}

/*  load the definitions of the map files */

void
loadmapconfig ()
{
  gchar mappath[400];
  FILE *st;
  gint i;
  gchar buf[512], s1[40], s2[40], s3[40];
  gint p, e;
  strcpy (mappath, homedir);
  strcat (mappath, "map_koord.txt");
  st = fopen (mappath, "r");
  if (st == NULL)
    {
      mkdir (homedir, 0777);
      st = fopen (mappath, "w+");
      if (st == NULL)
	{
	  perror (mappath);
	  exit (2);
	}
      st = freopen (mappath, "r", st);
      if (st == NULL)
	{
	  perror (mappath);
	  exit (2);
	}

    }
  maps = g_new (mapsstruct, sizeof (mapsstruct));
  i = 0;
  while ((p = fgets (buf, 512, st) != 0))
    {
      e = sscanf (buf, "%s %s %s %s", (maps + i)->filename, s1, s2, s3);
      g_strdelimit (s1, ",", '.');
      g_strdelimit (s2, ",", '.');
      g_strdelimit (s3, ",", '.');
      (maps + i)->lat = g_strtod (s1, NULL);
      (maps + i)->longitude = g_strtod (s2, NULL);
      (maps + i)->scale = strtol (s3, NULL, 0);
      i++;
      if (e == 4)
	nrmaps = i;
      maps = g_renew (mapsstruct, maps, (i + 1) * sizeof (mapsstruct));
    }
  fclose (st);
}

/*  write the definitions of the map files */
/* Attention! program  writes decimal point as set in locale
   i.eg 4.678 is in Germany 4,678 !!! */
void
savemapconfig ()
{
  gchar mappath[400];
  FILE *st;
  gint i;
  strcpy (mappath, homedir);
  strcat (mappath, "map_koord.txt");
  st = fopen (mappath, "w");
  if (st == NULL)
    {
      perror (mappath);
      exit (2);
    }

  for (i = 0; i < nrmaps; i++)
    {
      fprintf (st, "%s %.5f %.5f %ld\n", (maps + i)->filename,
	       (maps + i)->lat, (maps + i)->longitude, (maps + i)->scale);
    }

  fclose (st);
}

/* stores the track into a file, if argument testname is true, no saving is 
   done, only savetrackfn is set */
void
savetrackfile (gint testname)
{
  struct stat sbuf;
  gchar buff[1024];
  gint e, i;
  gchar mappath[400], lat[30], longi[30];
  FILE *st;

  if (testname)
    {
      i = 0;
      do
	{
	  sprintf (buff, "%strack%04d.sav", homedir, i++);
	  e = stat (buff, &sbuf);
	}
      while (e == 0);
      strcpy (savetrackfn, g_basename (buff));
      return;
    }


  strcpy (mappath, homedir);
  strcat (mappath, savetrackfn);
  st = fopen (mappath, "w");
  if (st == NULL)
    {
      perror (mappath);
      return;
    }

  for (i = 0; i < trackcoordnr; i++)
    {
      sprintf (lat, "%10.6f", (trackcoord + i)->lat);
      g_strdelimit (lat, ",", '.');
      sprintf (longi, "%10.6f", (trackcoord + i)->longi);
      g_strdelimit (longi, ",", '.');

      fprintf (st, "%s %s %s\n", lat, longi, (trackcoord + i)->postime);
    }
  fclose (st);
}



gint
gettrackfile (GtkWidget *widget, gpointer datum)
{
  gchar *fn, buf[520], lat[30], longi[30];
  FILE *st;
  gint i;

  fn = gtk_file_selection_get_filename (datum);
  st = fopen (fn, "r");
  if (st == NULL)
    {
      perror (fn);
      return TRUE;
    }
  g_free (trackcoord);
  g_free (track);
  track = g_new (trackstruct, 100000);
  tracknr = 0;
  trackcoord = g_new (trackcoordstruct, 100000);
  trackcoordnr = 0;
  i = 0;
  while (fgets (buf, 512, st))
    {
      sscanf (buf, "%s %s", lat, longi);
      (trackcoord + i)->lat = g_strtod (lat, NULL);
      (trackcoord + i)->longi = g_strtod (longi, NULL);
      i++;
      trackcoordnr++;
    }
  (trackcoord + i)->lat = 1001.0;
  (trackcoord + i)->longi = 1001.0;

  trackcoordnr++;

  rebuildtracklist ();
  fclose (st);
  gtk_widget_destroy (datum);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), TRUE);

  return TRUE;
}


/* Load track file and displays it */
gint
loadtrack_cb (GtkWidget *widget, gpointer datum)
{
  GtkWidget *fdialog;
  gchar buf[1000];
  fdialog = gtk_file_selection_new (_("Select a track file"));
  gtk_window_set_modal (GTK_WINDOW (fdialog), TRUE);

  gtk_signal_connect (GTK_OBJECT
		      (GTK_FILE_SELECTION (fdialog)->ok_button),
		      "clicked", GTK_SIGNAL_FUNC (gettrackfile),
		      GTK_OBJECT (fdialog));
  gtk_signal_connect_object (GTK_OBJECT
			     (GTK_FILE_SELECTION (fdialog)->
			      cancel_button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (fdialog));


  strcpy (buf, homedir);
  strcat (buf, "track*.sav");
  gtk_file_selection_complete (GTK_FILE_SELECTION (fdialog), buf);
  gtk_widget_show (fdialog);

  return TRUE;
}


/*  load the waypoint from way.txt, if success we display the sel target window */
void
loadwaypoints ()
{
  gchar mappath[400];
  FILE *st;
  gint i, e, p;
  gchar buf[512];
  strcpy (mappath, homedir);
  strcat (mappath, "way.txt");
  st = fopen (mappath, "r");
  if (st == NULL)
    {
      perror (mappath);
      maxwp = 0;
    }
  else
    {
      wayp = g_new (wpstruct, sizeof (wpstruct));
      i = 0;
      while ((p = fgets (buf, 512, st) != 0))
	{
	  e = sscanf (buf, "%s %lg %lg \n", (wayp + i)->name,
		      &(wayp + i)->lat, &(wayp + i)->longitude);
/*  limit waypoint name to 20 chars */
	  (wayp + i)->name[20] = 0;
	  if (e != 3)
	    {
	      wrongwplist = i + 1;
/*  	      error_popup (NULL, (gpointer *) error->str); */
/*  	      g_string_free (error, TRUE); */
	      maxwp = 0;
	      return;
	    }

	  if ((strncmp ((wayp + i)->name, "DEFAUL", 6)) == 0)
	    {
	      havedefaultpos = TRUE;
	      zero_lat = (wayp + i)->lat;
	      zero_long = (wayp + i)->longitude;
	      current_long = zero_long;
	      current_lat = zero_lat;
	      target_long = current_long + 0.0001;
	      target_lat = current_lat + 0.0001;
	    }
	  (wayp + i)->dist = 0;
	  i++;
	  if (e == 3)
	    maxwp = i;
	  wayp = g_renew (wpstruct, wayp, (i + 1) * sizeof (wpstruct));
	}
      fclose (st);
    }

}

/*  Main program */
int
main (int argc, char *argv[])
{
  GtkWidget *vbig, *vbig1, *vbox, *vbox2, *vbox3, *vbox4, *hbig, *hbox2,
    *downloadbt;
/*    GtkWidget *downloadwp; */
  GtkWidget *quit, *zoomin, *helpbt, *hbox3;
  GtkWidget *menuwin, *menuwin2;
  GtkWidget *zoomout, *sel_target;
  GtkWidget *f1, *f2, *f3, *f4, *f5, *f6, *f7, *lab1;
  GString *maintitle;
  struct sockaddr_in server;
  struct hostent *server_data;
  GdkColormap *cmap;
  GdkRectangle rectangle = {
    0, 0, SCREEN_X, SCREEN_Y
  };
  gchar *hd;
  GdkFont *myfont;
  gint i, h;
  GtkWidget *table1, *lf1, *lf2, *lf3, *lf4, *lf5, *lf6, *lf7, *lf8;
  GtkTooltips *tooltips;
  GdkPixmap *icon;
  GdkBitmap *mask;
  gchar s1[100], s2[100], *p, *localestring, **lstr, lstr2[200];

/*  initialize variables */
/*  Graz */
  zero_lat = 47.07924;
  zero_long = 15.45243;
/*    zero_lat and zero_long are overwritten by waypoint DEFAULT,  */
/*  if this name exists in the waypoint list. */
#define HAMBURGXX
#ifdef HAMBURG
/*  Hamburg */
  zero_lat = 53.55459;
  zero_long = 9.99089;
#endif
  current_long = zero_long;
  current_lat = zero_lat;
  target_long = zero_long + 0.00001;
  target_lat = zero_lat + 0.00001;
  direction = angel_to_destination = 0;
  strcpy (targetname, _("Daheim"));
  strcpy (oldangel, "none");
  pixelfact = MAPSCALE / PIXELFACT;
  strcpy (oldfilename, "");
  tempimage = image = NULL;
  simmode = maploaded = FALSE;
  haveNMEA = FALSE;
  havepos = gblink = blink = FALSE;
  haveposcount = haveGARMIN = debug = 0;
  zoom = 1;
  milesflag = iszoomed = FALSE;
  sel_target = NULL;
  timer = g_timer_new ();
  disttimer = g_timer_new ();
  g_timer_start (timer);
  g_timer_start (disttimer);
  memset (satlist, 0, sizeof (satlist));
  memset (satlistdisp, 0, sizeof (satlist));
  buffer = g_new (char, 2010);
  big = g_new (char, MAXBIG + 10);
  friendsbuffer = g_new (char, 200000);
  friendsbuffer[0] = 0;
  friendsbuffstart = friendsbuffend = NULL;

  timeoutcount = lastp = bigp = bigpGSV = 0;
  downloadfilelen = gcount = xoff = yoff = 0;
  hours = minutes = 99;
  milesconv = 1.0;
  downloadwindowactive = downloadactive = importactive = FALSE;
  strcpy (lastradar, "");
  strcpy (lastradar2, "");

  voicelang = english;
  track = g_new (trackstruct, 100000);
  tracknr = 0;
  trackcoord = g_new (trackcoordstruct, 100000);
  trackcoordnr = 0;
  tracklimit = trackcoordlimit = 100000;
  earthr = calcR (current_lat);
/*    homedir is the directory where the maps and other  */
/*  files are stored (~/.gpsdrive) */
  hd = g_get_home_dir ();
  strcpy (homedir, hd);
  strcat (homedir, "/.gpsdrive/");
/*  load waypoints before locale is set! */
/*  Attention! In this file the decimal point is always a '.' !! */
  loadwaypoints ();
/*  I18l */

/*  Detect the language for voice output */
  localestring = setlocale (LC_ALL, "");
  if (localestring == NULL)
    localestring = setlocale (LC_MESSAGES, "");
  if (localestring != NULL)
    {
      lstr = g_strsplit (localestring, ";", 50);
      strcpy (lstr2, "");
      for (i = 0; i < 50; i++)
	if (lstr[i] != NULL)
	  {
	    if ((strstr (lstr[i], "LC_MESSAGES")) != NULL)
	      {
		strcpy (lstr2, lstr[i]);
		break;
	      }
	  }
	else
	  {
	    strcpy (lstr2, lstr[i - 1]);
	    break;
	  }
    }
  if ((strstr (lstr2, "de_")) != NULL)
    voicelang = german;
  else if ((strstr (lstr2, "es_")) != NULL)
    voicelang = spanish;
  else
    voicelang = english;

/*  load mapfile configurations */
/*  Attention! In this file the decimal point is that what locale says, 
i.e. '.' in english, ',' in german!! */
  loadmapconfig ();
  p = bindtextdomain (PACKAGE, LOCALEDIR);
  p = textdomain (PACKAGE);
  p = textdomain (NULL);
/*    needed for right decimal delimiter ('.' or ',') */
  mylocale = localeconv ();
/*    Setting locale for correct Umlauts */
  gtk_set_locale ();
/*  initialization for GTK+ */
  gtk_init (&argc, &argv);
/* Needed 4 hours to find out that this is IMPORTANT!!!! */
  gdk_rgb_init ();
/*    This is exchanged, we turn it in miles_cb call */
  if (mylocale->decimal_point[0] == '.')
    milesflag = FALSE;
  else
    milesflag = TRUE;

/*  Default serial device for GARMIN mode only */
  strcpy (serialdev, "/dev/gps");

/*  Build array for earth radii */
  for (i = -100; i <= 100; i++)
    Ra[i + 100] = calcR (i);

  gethostname (hostname, 256);
  proxyport = 80;
  haveproxy = FALSE;

  p = g_getenv ("HTTP_PROXY");
  if (p)
    {
      g_strdelimit (p, ":/", ' ');

      i = sscanf (p, "%s %s %d", s1, s2, &proxyport);
      if (i == 3)
	{
	  haveproxy = TRUE;
	  strcpy (proxy, s2);
	  g_print (_("\nUsing proxy: %s on port %d"), proxy, proxyport);
	}
      else
	{
	  g_print (_("\nInvalid enviroment variable HTTP_PROXY, "
		     "must be in format: http://proxy.provider.de:3128"));
	}

    }

  h = gdk_screen_height ();
/*    g_print ("\nHhe: %d\n", h); */
  strcpy (friendsserver, "localhost");
  strcpy (friendsname, _("Unknown"));
  /* parse cmd args */
  do
    {
      i = getopt (argc, argv, "xvdhmn:f:l:t:s:o:?");
      switch (i)
	{
	case 'd':
	  debug = 1;
	  break;
	case 'x':
	  extrawinmenu = TRUE;
	  break;
	case 'v':
	  printf ("\ngpsdrive (c) 2001 Fritz Ganter <ganter@ganter.at>\n"
		  "\nVersion %s\n%s\n\n", VERSION, rcsid);
	  exit (0);
	  break;
	case 't':
	  strcpy (serialdev, optarg);
	  break;
	case 'f':
	  strcpy (friendsserver, optarg);
	  break;
	case 'n':
	  strcpy (friendsname, optarg);
	  break;
	case 's':
	  h = strtol (optarg, NULL, 0);
	  break;
	case 'l':
	  if (!strcmp (optarg, "english"))
	    voicelang = english;
	  else if (!strcmp (optarg, "german"))
	    voicelang = german;
	  else if (!strcmp (optarg, "spanish"))
	    voicelang = spanish;
	  else
	    {
	      usage ();
	      g_print (_
		       ("\nYou can only choose between english, spanish and german\n\n"));
	      exit (0);
	    }
	  break;
	case 'o':
	  nmeaout = opennmea (optarg);
	  break;
	case 'm':
	  /*  Set milesflag FALSE but */
	  /*  this is exchanged, we turn it in miles_cb call  */
	  milesflag = TRUE;
	  break;
	case 'h':
	  usage ();
	  exit (0);
	  break;
	case '?':
	  usage ();
	  exit (0);
	  break;
	}
    }
  while (i != -1);
/*  show splash screen */
  splash ();
/* Create toplevel window */

  real_screen_x = 640;
  real_screen_y = 512;
  PSIZE = 50;
  SMALLMENU = 0;
#define YMINUS 67
  if (h >= 768)			/* 1024x768 */
    {
      real_screen_x = 640;
      real_screen_y = 512;
    }
  else if (h >= 600)		/* 800x600 */
    {
      real_screen_x = 620;
      real_screen_y = 380;
    }
  else if (h >= 480)		/* 640x480 */
    {
      real_screen_x = 630;
      real_screen_y = h - YMINUS;
      extrawinmenu = TRUE;
    }
  else if (h < 480)		/* 320x200 */
    {
      real_screen_x = 220;
      real_screen_y = h - YMINUS;
      extrawinmenu = TRUE;
      PSIZE = 25;
      SMALLMENU = 1;
    }
  SCREEN_X_2 = SCREEN_X / 2;
  SCREEN_Y_2 = SCREEN_Y / 2;

  posx = SCREEN_X_2;
  posy = SCREEN_Y_2;

  mainwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_transient_for (GTK_WINDOW (splash_window),
				GTK_WINDOW (mainwindow));
  maintitle = g_string_new (NULL);
  g_string_sprintf (maintitle,
		    "%s Version %s (c) 2001 Fritz Ganter",
		    "gpsdrive", VERSION);
  gtk_window_set_title (GTK_WINDOW (mainwindow), maintitle->str);
  gtk_container_set_border_width (GTK_CONTAINER (mainwindow), 0);
  gtk_window_set_position (GTK_WINDOW (mainwindow), GTK_WIN_POS_CENTER);
  gtk_signal_connect (GTK_OBJECT (mainwindow), "delete_event",
		      GTK_SIGNAL_FUNC (quit_program), NULL);
  status = gtk_statusbar_new ();
  statusid = gtk_statusbar_get_context_id (GTK_STATUSBAR (status), "main");
  gtk_statusbar_push (GTK_STATUSBAR (status), statusid,
		      _("(c)2001 F.Ganter"));
  havespeechout = speech_out_init ();
  if (havespeechout)
    gtk_statusbar_push (GTK_STATUSBAR (status), statusid,
			_("Using speech output"));
  switch (voicelang)
    {
    case english:
      speech_out_speek (FESTIVAL_ENGLISH_INIT);
      break;
    case spanish:
      speech_out_speek (FESTIVAL_SPANISH_INIT);
      break;
    case german:
      speech_out_speek (FESTIVAL_GERMAN_INIT);
      break;
    }


  vbig = gtk_vbox_new (FALSE, 2);
  hbig = gtk_hbox_new (FALSE, 2);

/*  download map button */
  downloadbt = gtk_button_new_with_label (_("Download map"));
  gtk_signal_connect (GTK_OBJECT (downloadbt),
		      "clicked", GTK_SIGNAL_FUNC (download_cb), (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (downloadbt, GTK_CAN_DEFAULT); */
/*  download waypoint button */
/*    if (haveGARMIN) */
/*      { */
/*        downloadwp = gtk_button_new_with_label (_("Load GARMIN WP")); */
/*        gtk_signal_connect (GTK_OBJECT (downloadwp), */
/*  			  "clicked", GTK_SIGNAL_FUNC (downloadwp_cb), */
/*  			  (gpointer) 1); */
/*        GTK_WIDGET_SET_FLAGS (downloadwp, GTK_CAN_DEFAULT); */
/*      } */
/*  Quit button */
  quit = gtk_button_new_with_label (_("Quit"));
  gtk_signal_connect (GTK_OBJECT (quit),
		      "clicked", GTK_SIGNAL_FUNC (quit_program), 0);
/*    GTK_WIDGET_SET_FLAGS (quit, GTK_CAN_DEFAULT); */
/*  miles/kilometer button */
  miles = gtk_check_button_new_with_label (_("Miles"));
  gtk_signal_connect (GTK_OBJECT (miles),
		      "clicked", GTK_SIGNAL_FUNC (miles_cb), (gpointer) 1);

/*  set label for current miles flag */
  if (!milesflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (miles), TRUE);
  else
    miles_cb (0, 0);

  if (havespeechout)
    {
      mutebt = gtk_check_button_new_with_label (_("Mute"));
      gtk_signal_connect (GTK_OBJECT (mutebt),
			  "clicked", GTK_SIGNAL_FUNC (mute_cb), (gpointer) 1);
    }
  if (maxwp > 0)
    {
      wpbt = gtk_check_button_new_with_label (_("Show WP"));
      gtk_signal_connect (GTK_OBJECT (wpbt),
			  "clicked", GTK_SIGNAL_FUNC (wp_cb), (gpointer) 1);
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), TRUE);
    }
  trackbt = gtk_check_button_new_with_label (_("Show Track"));
  gtk_signal_connect (GTK_OBJECT (trackbt),
		      "clicked", GTK_SIGNAL_FUNC (track_cb), (gpointer) 1);

  importbt = gtk_button_new_with_label (_("Import"));
  gtk_signal_connect (GTK_OBJECT (importbt),
		      "clicked", GTK_SIGNAL_FUNC (import1_cb), (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (importbt, GTK_CAN_DEFAULT); */

  loadtrackbt = gtk_button_new_with_label (_("Load track"));
  gtk_signal_connect (GTK_OBJECT (loadtrackbt),
		      "clicked", GTK_SIGNAL_FUNC (loadtrack_cb),
		      (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (loadtrackbt, GTK_CAN_DEFAULT); */

  helpbt = gtk_button_new_with_label (_("Help"));
  gtk_signal_connect (GTK_OBJECT (helpbt),
		      "clicked", GTK_SIGNAL_FUNC (help_cb), (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (helpbt, GTK_CAN_DEFAULT); */

  bestmapbt = gtk_check_button_new_with_label (_("Auto best map"));
  gtk_signal_connect (GTK_OBJECT (bestmapbt),
		      "clicked", GTK_SIGNAL_FUNC (bestmap_cb), (gpointer) 1);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), FALSE);


  savetrackfile (TRUE);
  sprintf (s1, "%s", _("Save track"));
  savetrackbt = gtk_check_button_new_with_label (s1);
  gtk_signal_connect (GTK_OBJECT (savetrackbt),
		      "clicked", GTK_SIGNAL_FUNC (savetrack_cb),
		      (gpointer) 1);

  sprintf (s1, "%s", savetrackfn);
  lab1 = gtk_label_new (s1);

  f6 = gtk_frame_new (_("Shown map type"));
  vbox3 = gtk_vbox_new (TRUE, 1);
  gtk_container_add (GTK_CONTAINER (f6), vbox3);

  f7 = gtk_frame_new (NULL);
  vbox4 = gtk_vbox_new (TRUE, 1);
  gtk_container_add (GTK_CONTAINER (f7), vbox4);


  maptogglebt = gtk_check_button_new_with_label (_("Street map"));
  gtk_signal_connect (GTK_OBJECT (maptogglebt),
		      "clicked", GTK_SIGNAL_FUNC (maptoggle_cb),
		      (gpointer) 1);
  topotogglebt = gtk_check_button_new_with_label (_("Topo map"));
  gtk_signal_connect (GTK_OBJECT (topotogglebt),
		      "clicked", GTK_SIGNAL_FUNC (topotoggle_cb),
		      (gpointer) 1);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), TRUE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), TRUE);
  gtk_box_pack_start (GTK_BOX (vbox3), maptogglebt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox3), topotogglebt, FALSE, FALSE, 1);



/*  Zoom in button */
  zoomin = gtk_button_new_with_label (_("Zoom in"));
  gtk_signal_connect (GTK_OBJECT (zoomin),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (zoomin, GTK_CAN_DEFAULT); */
/*  Zoom out button */
  zoomout = gtk_button_new_with_label (_("Zoom out"));
  gtk_signal_connect (GTK_OBJECT (zoomout),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 2);
/*    GTK_WIDGET_SET_FLAGS (zoomout, GTK_CAN_DEFAULT); */


  scalerrbt = gtk_button_new_with_label (">>");
  gtk_signal_connect (GTK_OBJECT (scalerrbt),
		      "clicked", GTK_SIGNAL_FUNC (scalerbt_cb), (gpointer) 1);
/*    GTK_WIDGET_SET_FLAGS (scalerrbt, GTK_CAN_DEFAULT); */
  scalerlbt = gtk_button_new_with_label ("<<");
  gtk_signal_connect (GTK_OBJECT (scalerlbt),
		      "clicked", GTK_SIGNAL_FUNC (scalerbt_cb), (gpointer) 2);
/*    GTK_WIDGET_SET_FLAGS (scalerlbt, GTK_CAN_DEFAULT); */

/*  Select target button */
  if (maxwp > 0)
    {
      sel_target = gtk_button_new_with_label (_("Select target"));
      gtk_signal_connect (GTK_OBJECT (sel_target),
			  "clicked",
			  GTK_SIGNAL_FUNC (sel_target_cb), (gpointer) 2);
/*        GTK_WIDGET_SET_FLAGS (sel_target, GTK_CAN_DEFAULT); */
    }

/*    gtk_window_set_default (GTK_WINDOW (mainwindow), zoomin); */
/*    if we want NMEA mode, gpsd must be running and we connect to port 2222 */
/*    An alternate gpsd server may be on 2947, we try it also */

/*  We test for gpsd serving */
  {
/*  open socket to port */
    if ((sock = socket (AF_INET, SOCK_STREAM, 0)) < 0)
      {
	perror (_("can't open socket for port "));
	exit (1);
      }
    server.sin_family = AF_INET;
/*  We retrieve the IP address of the server from its name: */
    if ((server_data = gethostbyname (SERVERNAME)) == NULL)
      {
	fprintf (stderr, "%s: unknown host", SERVERNAME);
	exit (1);
      }
    memcpy (&server.sin_addr, server_data->h_addr, server_data->h_length);
    server.sin_port = htons (SERVERPORT);

/*  We initiate the connection  */
    if (connect (sock, (struct sockaddr *) &server, sizeof server) < 0)
      {
	server.sin_port = htons (SERVERPORT2);	/* We try second port */
/*  We initiate the connection  */
	if (connect (sock, (struct sockaddr *) &server, sizeof server) < 0)
	  {
	    haveNMEA = FALSE;
	    simmode = TRUE;
	  }
	else
	  {
	    haveNMEA = TRUE;
	    simmode = FALSE;
	    strcpy (nmeamodeandport, _("NMEA Mode, Port 2947"));
	    write (sock, "R\n", 2);
	  }
      }
    else
      {
	strcpy (nmeamodeandport, _("NMEA Mode, Port 2222"));
	haveNMEA = TRUE;
	simmode = FALSE;
      }


  }
  if (!haveNMEA)
    {
      typedef struct
      {
	gchar *a1;
	gchar *a2;
	gchar *a3;
      }
      argument;
      argument *argumente;
      gint e;

      argumente = g_new (argument, 1);
      argumente->a1 = "-p";
      argumente->a2 = "-p";
      argumente->a3 = 0;

      e = garblemain (1, (char **) argumente);

      if (e == -2)
	{
	  strcpy (serialdev, "/dev/ttyS0");
	  e = garblemain (1, (char **) argumente);
	  if (e == -2)
	    {
	      haveGARMIN = FALSE;
	      simmode = TRUE;
	    }
	  else
	    {
	      haveGARMIN = TRUE;
	      simmode = FALSE;
	    }
	}
      else
	{
	  haveGARMIN = TRUE;
	  simmode = FALSE;
	}
      g_free (argumente);
    }

  openfriendsport ();
  if (havefriends)
    {
      loadfriendsicon ();
/*  limit to 1000 friends at the moment */
      friends = g_new (friendsstruct, 1000);
    }
/*  Area for map */
  drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), SCREEN_X, SCREEN_Y);
  gtk_box_pack_start (GTK_BOX (vbig), drawing_area, TRUE, TRUE, 2);
  gtk_widget_add_events (GTK_WIDGET (drawing_area), GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect_object (GTK_OBJECT (drawing_area),
			     "button-press-event",
			     GTK_SIGNAL_FUNC (mapclick_cb),
			     GTK_OBJECT (drawing_area));
/* Area for navigation pointer */
  drawing_area2 = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area2), PSIZE, PSIZE);
/* Area for mini map */
  drawing_area4 = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area4), 128, 103);
  gtk_signal_connect (GTK_OBJECT (drawing_area4),
		      "expose_event", GTK_SIGNAL_FUNC (exposemini_cb), NULL);

  hbox2 = gtk_hbox_new (FALSE, 1);
  hbox3 = gtk_hbox_new (FALSE, 1);
  f1 = gtk_frame_new (_("Bearing"));
  gtk_container_add (GTK_CONTAINER (f1), drawing_area2);
  gtk_box_pack_start (GTK_BOX (hbox2), f1, FALSE, FALSE, 1);
/* Area for field strength, we have data only in NMEA mode */
  if (haveNMEA)
    {
      drawing_area3 = gtk_drawing_area_new ();
      gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area3), PSIZE, PSIZE);
      f2 = gtk_frame_new (_("Sat level"));
      gtk_container_add (GTK_CONTAINER (f2), drawing_area3);
      gtk_box_pack_start (GTK_BOX (hbox2), f2, FALSE, FALSE, 1);
    }
/*  displays distance to destination */
  distlabel = gtk_label_new (_("---km"));
  gtk_label_set_justify (GTK_LABEL (distlabel), GTK_JUSTIFY_RIGHT);
/*  displays speed over ground */
  speedlabel = gtk_label_new (_("---km/h"));
  gtk_label_set_justify (GTK_LABEL (speedlabel), GTK_JUSTIFY_RIGHT);
/*  displays zoom factor of map */
  zoomlabel = gtk_label_new (_("--x"));
  gtk_label_set_justify (GTK_LABEL (zoomlabel), GTK_JUSTIFY_RIGHT);

/*    We load a large font for above labels, if we can't get the first */
/*  we try the next */
  if (PSIZE >= 50)
    myfont = gdk_font_load (FONT1);
  else
    myfont = gdk_font_load (FONTTINY);

  if (myfont == NULL)
    myfont = gdk_font_load (FONT2);
  style = gtk_style_copy (gtk_widget_get_style (distlabel));
  if (myfont != NULL)
    style->font = myfont;
  style->fg[0] = blue;
  gtk_widget_push_style (style);
  textfont = gdk_font_load (TEXTFONT);
  if (textfont == NULL)
    textfont = gdk_font_load (TEXTFONT2);
  smalltextfont = gdk_font_load (SMALLTEXTFONT);
  if (smalltextfont == NULL)
    smalltextfont = gdk_font_load (SMALLTEXTFONT2);

  gtk_widget_set_style (GTK_WIDGET (distlabel), style);
  gtk_widget_set_style (GTK_WIDGET (speedlabel), style);
  gtk_widget_set_style (GTK_WIDGET (zoomlabel), style);
  gtk_widget_pop_style ();

  style = gtk_style_copy (gtk_widget_get_style (lab1));
  style->fg[0] = red;
  gtk_widget_set_style (GTK_WIDGET (lab1), style);
  gtk_widget_pop_style ();


/*  create frames for labels */
  f3 = gtk_frame_new (_("Distance to target"));
  destframe = f3;
  gtk_container_add (GTK_CONTAINER (f3), distlabel);
  gtk_box_pack_start (GTK_BOX (hbox2), f3, TRUE, TRUE, 2);
  f4 = gtk_frame_new (_("Speed"));
  gtk_container_add (GTK_CONTAINER (f4), speedlabel);
  gtk_box_pack_start (GTK_BOX (hbox2), f4, TRUE, TRUE, 1);
  f5 = gtk_frame_new (_("Zoom"));
  gtk_container_add (GTK_CONTAINER (f5), zoomlabel);
  gtk_box_pack_start (GTK_BOX (hbox2), f5, FALSE, TRUE, 1);
#ifdef WANTSHADOW
  gtk_frame_set_shadow_type (GTK_FRAME (f1), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (f3), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (f4), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (f5), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (f2), GTK_SHADOW_IN);
#endif
/*    gtk_box_pack_start (GTK_BOX (vbig), hbox2, TRUE, TRUE, 2); */
  vbox = gtk_vbox_new (TRUE, 4);
  gtk_box_pack_start (GTK_BOX (vbox), zoomin, FALSE, FALSE, 3);
  gtk_box_pack_start (GTK_BOX (vbox), zoomout, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), hbox3, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (hbox3), scalerlbt, TRUE, TRUE, 1);
  gtk_box_pack_start (GTK_BOX (hbox3), scalerrbt, TRUE, TRUE, 1);
/*  only if we have read in waypoints we have the select target button */
  if (maxwp > 0)
    gtk_box_pack_start (GTK_BOX (vbox), sel_target, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), downloadbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), importbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), loadtrackbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), helpbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox), quit, FALSE, FALSE, 1);
  vbox2 = gtk_vbox_new (FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox, TRUE, TRUE, 1);
  gtk_box_pack_start (GTK_BOX (vbox2), f7, TRUE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox2), f6, TRUE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox2), GTK_WIDGET (drawing_area4), TRUE,
		      TRUE, 1);

  if (havespeechout)
    gtk_box_pack_start (GTK_BOX (vbox4), mutebt, FALSE, FALSE, 1);
  if (maxwp > 0)
    gtk_box_pack_start (GTK_BOX (vbox4), wpbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox4), trackbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox4), miles, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox4), bestmapbt, FALSE, FALSE, 1);
  gtk_box_pack_start (GTK_BOX (vbox4), savetrackbt, FALSE, FALSE, 1);
/*    gtk_box_pack_start (GTK_BOX (vbox4), lab1, TRUE, TRUE, 1); */


  adj = gtk_adjustment_new (12, 0, 29, 1, 4, 0.034);
  scaler = gtk_hscale_new (GTK_ADJUSTMENT (adj));
  gtk_signal_connect (GTK_OBJECT (adj), "value_changed",
		      GTK_SIGNAL_FUNC (scaler_cb), NULL);
  gtk_scale_set_draw_value (GTK_SCALE (scaler), FALSE);
/*    if (haveGARMIN) */
/*      gtk_box_pack_start (GTK_BOX (vbox3), downloadwp, FALSE, FALSE, 1); */
  if (SMALLMENU)
    table1 = gtk_table_new (4, 3, FALSE);
  else
    table1 = gtk_table_new (8, 2, FALSE);
  lf1 = gtk_frame_new (_("Latitude"));
  lf2 = gtk_frame_new (_("Longitude"));
  lf3 = gtk_frame_new (_("Map file"));
  lf4 = gtk_frame_new (_("Map scale"));
  lf5 = gtk_frame_new (_("Heading"));
  lf6 = gtk_frame_new (_("Bearing"));
  lf7 = gtk_frame_new (_("Time at Dest."));
  lf8 = gtk_frame_new (_("Pref. scale"));
#ifdef WANTSHADOW
  gtk_frame_set_shadow_type (GTK_FRAME (lf1), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf2), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf3), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf4), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf5), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf6), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf7), GTK_SHADOW_IN);
  gtk_frame_set_shadow_type (GTK_FRAME (lf8), GTK_SHADOW_IN);
#endif
  l1 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf1), l1);
  l2 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf2), l2);
  l3 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf3), l3);
  l4 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf4), l4);
  l5 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf5), l5);
  l6 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf6), l6);
  l7 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf7), l7);
  l8 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf8), l8);
  if (SMALLMENU)
    {
      gtk_table_attach_defaults (GTK_TABLE (table1), lf1, 0, 1, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf2, 1, 2, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf5, 2, 3, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf6, 3, 4, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf7, 0, 1, 1, 2);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf3, 1, 2, 1, 2);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf4, 2, 3, 1, 2);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf8, 3, 4, 1, 2);
      gtk_table_attach_defaults (GTK_TABLE (table1), status, 0, 2, 2, 3);
      gtk_table_attach_defaults (GTK_TABLE (table1), scaler, 2, 4, 2, 3);
    }
  else
    {
      gtk_table_attach_defaults (GTK_TABLE (table1), lf1, 0, 1, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf2, 1, 2, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf5, 2, 3, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf6, 3, 4, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf7, 4, 5, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf3, 5, 6, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf4, 6, 7, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), lf8, 7, 8, 0, 1);
      gtk_table_attach_defaults (GTK_TABLE (table1), status, 0, 4, 1, 2);
      gtk_table_attach_defaults (GTK_TABLE (table1), scaler, 4, 8, 1, 2);
    }

/*    gtk_box_pack_start (GTK_BOX (vbig), table1, FALSE, FALSE, 1); */
/*  all position calculations are made in the expose callback */
  gtk_signal_connect (GTK_OBJECT (drawing_area),
		      "expose_event", GTK_SIGNAL_FUNC (expose_cb), NULL);
  if (extrawinmenu)
    {
      menuwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_window_set_title (GTK_WINDOW (menuwin), _("GpsDrive Menu"));
      gtk_container_set_border_width (GTK_CONTAINER (menuwin), 2);
      gtk_container_add (GTK_CONTAINER (menuwin), vbox2);
      gtk_signal_connect (GTK_OBJECT (menuwin), "delete_event",
			  GTK_SIGNAL_FUNC (quit_program), NULL);
      menuwin2 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_window_set_title (GTK_WINDOW (menuwin2), _("GpsDrive Status"));
      gtk_container_set_border_width (GTK_CONTAINER (menuwin2), 2);
      vbig1 = gtk_vbox_new (FALSE, 2);
      gtk_container_add (GTK_CONTAINER (menuwin2), vbig1);
      gtk_box_pack_start (GTK_BOX (vbig1), hbox2, TRUE, TRUE, 2);
      gtk_box_pack_start (GTK_BOX (vbig1), table1, TRUE, TRUE, 2);
      gtk_signal_connect (GTK_OBJECT (menuwin2), "delete_event",
			  GTK_SIGNAL_FUNC (quit_program), NULL);
    }
  else
    {
      gtk_box_pack_start (GTK_BOX (hbig), vbox2, TRUE, TRUE, 1);
      gtk_box_pack_start (GTK_BOX (vbig), hbox2, TRUE, TRUE, 2);
      gtk_box_pack_start (GTK_BOX (vbig), table1, FALSE, FALSE, 1);
    }

  gtk_box_pack_start (GTK_BOX (hbig), vbig, TRUE, TRUE, 1);
  gtk_container_add (GTK_CONTAINER (mainwindow), hbig);
/*  Now show all Widgets */
  gtk_widget_show_all (mainwindow);
  if (extrawinmenu)
    {
      gtk_widget_show_all (menuwin);
      gtk_widget_show_all (menuwin2);

    }
  icon =
    gdk_pixmap_create_from_xpm_d (mainwindow->window, &mask,
				  NULL, gpsico_xpm);
  gdk_window_set_icon (mainwindow->window, NULL, icon, mask);
/*  now we know the drawables */
  drawable = gdk_pixmap_new (mainwindow->window, SCREEN_X, SCREEN_Y, -1);
/*    drawable = drawing_area->window; */
  drawable2 = drawing_area2->window;
/*  satellite level is only avail. in NMEA mode */
  if (haveNMEA)
    drawable3 = drawing_area3->window;
  kontext = gdk_gc_new (mainwindow->window);
  gdk_gc_set_clip_origin (kontext, 0, 0);
  rectangle.width = SCREEN_X;
  rectangle.height = SCREEN_Y;

  gdk_gc_set_clip_rectangle (kontext, &rectangle);
  cmap = gdk_colormap_get_system ();
  gdk_color_alloc (cmap, &red);
  gdk_color_alloc (cmap, &black);
  gdk_color_alloc (cmap, &blue);
  gdk_color_alloc (cmap, &green);
  gdk_color_alloc (cmap, &white);
  gdk_color_alloc (cmap, &mygray);
  gdk_color_alloc (cmap, &yellow);
  gdk_color_alloc (cmap, &darkgrey);
  cursor = gdk_cursor_new (GDK_CROSS);
  gdk_window_set_cursor (drawing_area->window, cursor);
/*  Tooltips */
  tooltips = gtk_tooltips_new ();
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), downloadbt,
			_("Download map from Internet"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), quit,
			_("Leave the program"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), miles,
			_("Switch units between Miles and Kilometers"), NULL);
  if (havespeechout)
    gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), mutebt,
			  _("Disable output of speech"), NULL);
  if (maxwp > 0)
    gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), wpbt,
			  _("Show waypoints on the map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), trackbt,
			_("Show tracking on the map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), importbt,
			_("Let you import and calibrate your own map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), helpbt,
			_("Opens the help window"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), zoomin,
			_("Zoom into the current map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), zoomout,
			_("Zooms out off the current map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), scalerlbt,
			_("Select the next more detailed map"), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), scalerrbt,
			_("Select the next less detailed map"), NULL);
  if (maxwp > 0)
    gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips),
			  sel_target,
			  _
			  ("Select here a destination from the waypoint list"),
			  NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), scaler,
			_("Select the map scale of avail. maps."), NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), loadtrackbt,
			_("Load and display a previous stored track file"),
			NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), bestmapbt,
			_("Always select the most detailed map available"),
			NULL);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), savetrackbt,
			_("Save the track to given filename at program exit"),
			NULL);
/*    gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltips),,_(""),NULL); */
  gtk_tooltips_set_delay (GTK_TOOLTIPS (tooltips), 1000);
  strcpy (mapfilename, "***");
/*  set the timers */
  gtk_timeout_add (TIMER, (GtkFunction) get_position_data_cb, NULL);
  gtk_timeout_add (WATCHWPTIMER, (GtkFunction) watchwp_cb, NULL);
  gtk_timeout_add (REDRAWTIMER, (GtkFunction) drawmarker_cb, NULL);
/*  if we started in simulator mode we have a little move roboter */
  if (simmode)
    gtk_timeout_add (300, (GtkFunction) simulated_pos, 0);
  if (nmeaout)
    gtk_timeout_add (1000, (GtkFunction) write_nmea_cb, NULL);
  gtk_timeout_add (3000, (GtkFunction) testconfig_cb, 0);
  gtk_timeout_add (600000, (GtkFunction) speech_saytime_cb, 0);
  gtk_timeout_add (1000, (GtkFunction) storetrack_cb, 0);
  gtk_timeout_add (10000, (GtkFunction) masteragent_cb, 0);
  if (havefriends)
    {
      gtk_timeout_add (15000, (GtkFunction) friendsagent_cb, 0);
    }
  if (havespeechout)
    {
      speech_saytime_cb (NULL, 1);
      gtk_timeout_add (SPEECHOUTINTERVAL, (GtkFunction) speech_out_cb, 0);
    }

/*  Mainloop */
  gtk_main ();
  return 0;
}
